/*
 
  LANChat 4.0 for Windows 95OSR2/98/NT4
  --------------------------------------------------------
  (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)
 
  LANChat and related utilities are free software; you can
  redistribute it and/or modify it under the terms of the GNU Library
  General Public License as published by the Free Software Foundation;
  either version 2 of the License, or (at your option) any later version.
 
*/

#include "stdafx.h"
#include "LANChat.h"
#include "LANChatDlg.h"

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP( CLANChatApplication, CWinApp )
//{{AFX_MSG_MAP(CLANChatApplication)
//}}AFX_MSG
ON_COMMAND( ID_HELP, CWinApp::OnHelp )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

CLANChatApplication::CLANChatApplication()
{
	// nothing to do here :)
}

/////////////////////////////////////////////////////////////////////////////

CLANChatApplication LANChat40; // creating application

/////////////////////////////////////////////////////////////////////////////

BOOL CLANChatApplication::InitInstance()
{
  CLANChatDlg LANDialog;
  char DPI[5];
  HKEY hRegKey;
  DWORD dSize = 4;
  DWORD first;

  // beta notification
  //:MessageBox(NULL,"This is only a BETA-VERSION. Please test it and delete after 7 days\nfrom first use. Send your comments/bugs to lanchat@friko4.onet.pl\n\nThank you !","LANChat 4.0 BETA",MB_ICONWARNING|MB_OK);

  // initialize Windows Sockets and Rich Edit Box libraries
  if ( !AfxSocketInit() )
  {
    AfxMessageBox( IDP_SOCKETS_INIT_FAILED );
    return FALSE;
  }
  LoadLibrary( "RICHED32.DLL" );

  LANDialog.SetVariables();
  LANDialog.Language = LANG_UNDEFINED;
  m_pMainWnd = &LANDialog;

  // check font size - no other than 96 DPI supported
  RegOpenKeyEx( HKEY_LOCAL_MACHINE, "Config\\0001\\Display\\Settings",0,
                KEY_QUERY_VALUE,&hRegKey);
  RegQueryValueEx(hRegKey,"DPILogicalX",NULL,NULL,(unsigned char *)&DPI,&dSize);
  if (strcmp(DPI,"96")!=0)
  {
    ::MessageBox(NULL,"Non-standard fonts are not supported !\n\nLANChat does not support screen fonts other than 96 DPI (100%).\nPlease change the size of screen fonts and then run LANChat.","LANChat 4.0",MB_OK|MB_ICONWARNING);
    RegCloseKey(hRegKey);
    return FALSE;
  }
  else
  {
    RegCloseKey(hRegKey);
    RegCreateKeyEx( HKEY_CURRENT_USER, "SOFTWARE\\LANChat", 0,
                    NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
                    NULL, &hRegKey, &first );
	// first run notification
    if ( first == REG_CREATED_NEW_KEY )
      MessageBox( NULL, "\tWelcome to LANChat 4.0 !\n\nSince this is your first use of this program please click the Setup Icon (or hit F4)\nand set your favourite options in LANChat.", "LANChat 4.0", MB_OK | MB_ICONINFORMATION );
    dSize = 4; RegQueryValueEx( hRegKey, "Language", NULL, NULL, ( unsigned char * ) & LANDialog.Language, &dSize );
    RegCloseKey( hRegKey );

    LANDialog.hInstance = AfxGetResourceHandle();

	// minimized startup option ?
    if ( strlen( m_lpCmdLine ) > 0 ) LANDialog.Minimized = 1; else LANDialog.Minimized = 0;
    LANDialog.LANChatApp = this;

    // run dialog-based application
    // as a modal dialog (already created)

    // LAMER-PROTECTION
    // please add this line yourself

    // ....

    return FALSE;
  }
}
