/*
 *  LANChat 4.0 for Windows 95OSR2/98/NT4
 *  --------------------------------------------------------
 *  (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)
 *
 *  LANChat and related utilities are free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software Foundation;
 *  either version 2 of the License, or (at your option) any later version.
 *
 */

#if _MSC_VER < 1100
#error LANChat 4.0 requires Visual C++ 5.0
#endif

#include "stdafx.h"
#include "resource.h"

#include "LANChat.h"
#include "LANChatDlg.h"
#include "TopicDlg.h"
#include "SetupDlg.h"
#include "AwayDlg.h"
#include "AboutDlg.h"
#include "PrivateDlg.h"
#include "UsersDlg.h"
#include "PopUpDlg.h"

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP( CLANChatDlg, CDialog )
//{{AFX_MSG_MAP(CLANChatDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED( IDC_WYSLIJ, OnSendMsg )
ON_WM_TIMER()
ON_WM_CLOSE()
ON_MESSAGE( WM_TRAY, OnUser )
ON_BN_CLICKED( IDC_MIN, OnMin )
ON_BN_CLICKED( IDC_MOTH, OnMotherAttack )
ON_BN_CLICKED( IDC_CHECK1, OnCheckAway )
ON_WM_DESTROY()
ON_BN_CLICKED( IDC_CHECK2, OnCheckMute )
ON_BN_CLICKED( IDC_BSETUP, OnSetup )
ON_BN_CLICKED( IDC_BTOPIC, OnTopic )
ON_BN_CLICKED( IDC_BABOUT, OnAbout )
ON_BN_CLICKED( IDC_STATUSEX, OnStatusEx )
ON_NOTIFY( NM_CLICK, IDC_USERS, OnClickUsers )
ON_NOTIFY( NM_DBLCLK, IDC_USERS, OnDblclkUsers )
ON_COMMAND( IDC_MIN, OnMin )
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::SetVariables(void)
{
  HIVER[0]=(char)52^15; HIVER[1]=0;
  LOVER[0]=(char)56; LOVER[1]=(unsigned char)(0^(unsigned char)177); LOVER[2]=(char)0;
  BUILD[0]=(char)24; BUILD[1]=(char)59; BUILD[2]=(unsigned char)(49^(unsigned char)143); BUILD[3]=0;

  m_Away = 0;
  Dev = 0;
  Sn = 0;
  SecondCopy = 0;
  FirstRun = 0;
  Truth = TRUE;
  omsg = 1;
  strcpy(cRecData,"");
  strcpy(welcome,"");
  strcpy(message,"");
  FirstTimer = 1;

  strcpy(LC_Version,"LANChat 4.0");
  strcpy(LC_OS,"Windows");

}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnCancel()
{
  char grypsy[ 10 ][ 60 ] = {
    "Really quit ? You'd get a $50000 prize in 5 minutes...",
    "Do you want to quit LANChat ?",
    "LANChat is the best, is that right ?",
    "Are you a loser ?",
    "Do you want to be a lamer ?",
    "You want to quit LANChat, are you nuts ?",
    "I can't understand you. Are you OK ?",
    "Do you really want to leave your friends !?!?",
    "Do you promise you'll visit www.lanchat.topnet.pl ?",
    "Do you love Bill Gates ?"
  };
  int yt;
  ActDlg = 0;
  yt = MessageBox( grypsy[ rand() % 10 ], "Quit ?", MB_YESNO | MB_ICONQUESTION );
  if ( yt == IDYES )
  {
    ActDlg = 1;
    CDialog::OnCancel();
  }
  ActDlg = 1;
}

/////////////////////////////////////////////////////////////////////////////

CLANChatDlg::CLANChatDlg( CWnd* pParent )
    : CDialog( CLANChatDlg::IDD, pParent )
{
  //{{AFX_DATA_INIT(CLANChatDlg)
  m_Wpis = _T( "" );
  //}}AFX_DATA_INIT
  m_hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::DoDataExchange( CDataExchange* pDX )
{
  CDialog::DoDataExchange( pDX );
  //{{AFX_DATA_MAP(CLANChatDlg)
  DDX_Control( pDX, IDC_USERS, m_Users );
  DDX_Text( pDX, IDC_WPISYWANIE, m_Wpis );
  DDV_MaxChars(pDX, m_Wpis, 250);
  //}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::CountLAG( void )
{
  for ( unsigned int n = 0; n < 256; n++ )
  {
    if ( ( LAGs[ n ] > 3 ) && ( ( Status[ n ] == USER_PRESENT ) || ( Status[ n ] == USER_AWAY ) ) )
    {
      char mes[ 80 ];
      GetLocalTime( &Czas );
      if ( Language == US ) wsprintf( mes, "%s timed out at %02d:%02d:%02d.\n", Nick[ n ], Czas.wHour, Czas.wMinute, Czas.wSecond );
      else wsprintf( mes, "%s zamilk(a) o %02d:%02d:%02d.\n", Nick[ n ], Czas.wHour, Czas.wMinute, Czas.wSecond );
      if ( ( n == MyIP ) && ( NetAlive == 1 ) )
      {
        if ( Language == US )
          MessageBox( "Your network's loopback doesn't work - check the cables and connections.", "LANChat error!", MB_OK );
        else MessageBox( "Twoja sie nie dziaa prawidowo. Sprawd kable i poczenia.", "Bd LANChata!", MB_OK );
        NetAlive = 0;
      }
      if ( ( PChat[ n ] != NULL ) && ( n != MyIP ) )
      {
        CString Maniek;
        Maniek = Nick[ n ];
        Maniek += " [zombie]";
        PChat[ n ] ->SetWindowText( Maniek );
        PChat[ n ] ->AddText( 64, 64, 64, mes, 0, 0, 0 );
      }
      CleanNicks();
      SendLCMsg( LC_REQ_ALIVE, LC_BROADCAST, "" );
      AddText( 64, 64, 64, mes, 0, 1 );
      SetUser( n, USER_TIMED );
      LAGs[ n ] = 0;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::SetUser( unsigned int cIP, const int nStatus )
{
  if ( Status[ cIP ] != nStatus )
  {
    Status[ cIP ] = (char)nStatus;
    UpdateList();
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::SendLCMsg( const int cType, const int cDest, const char *Data )
{
  LC_DATA_HEAD LCMsg;
  unsigned int DataLength;

  // fill LC_DATA_HEAD structure
  LCMsg.cHead[ 0 ] = 'L'; LCMsg.cHead[ 1 ] = 'C';
  LCMsg.cHead[ 2 ] = '4'; LCMsg.cHead[ 3 ] = '0';
  LCMsg.cType = (unsigned char)cType;
  LCMsg.cSender = MyIP;
  LCMsg.cDest = cDest;
  LCMsg.nR = (unsigned char)SetupDialog->m_R;
  LCMsg.nG = (unsigned char)SetupDialog->m_G;
  LCMsg.nB = (unsigned char)SetupDialog->m_B;
  LCMsg.xVal = (unsigned char)(rand() % 8 + 11);
  LCMsg.cCrypt = CryptType[ cDest ];
  LCMsg.Female = (char)SetupDialog->Female;
  LCMsg.Reserved2 = 0;
  LCMsg.Reserved3 = 0;
  // prepare and crypt data
  strcpy( LCMsg.cNick, LPCTSTR( SetupDialog->m_Nick ) );
  strcpy( LCMsg.Data, Data );
  strcat( LCMsg.Data, "\x0d\x0a\0" );
  DataLength = strlen( LCMsg.Data );
  for ( unsigned int i = 0 ; i < DataLength ; i++ )
  {
    {
      LCMsg.Data[ i ] = ( unsigned char ) ( LCMsg.Data[ i ] + ( 20 - LCMsg.xVal ) );
      LCMsg.Data[ i ] = ( unsigned char ) ( 255 - LCMsg.Data[ i ] );
      LCMsg.Data[ i ] = ( unsigned char ) ( LCMsg.Data[ i ] + LCMsg.cSender + LCMsg.cDest );
      if ( LCMsg.cCrypt == CRYPT_SLC )
      {
        LCMsg.Data[ i ] = (unsigned char) ( LCMsg.Data[ i ] ^ ( (unsigned char)LCMsg.xVal + 107 ) );
        LCMsg.Data[ i ] ++;
      }
    }
  }
  LCMsg.Data[ i + 1 ] = 'L' ; LCMsg.Data[ i + 2 ] = 'C';
  LCMsg.Data[ i + 3 ] = '4' ; LCMsg.Data[ i + 4 ] = '0';
  // send data
  SendingSock.SendTo( &LCMsg, DataLength + sizeof( LC_DATA_HEAD ) - 4096 + 7, INPORT, NULL, 0 );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::CleanNicks( void )
{
  m_Users.DeleteAllItems();
  aUsers = 0;
  UpdateData( TRUE );
  for ( int i = 0; i < 255; i++ )
  {
    strcpy( Nick[ i ], "" );
    Status[ i ] = USER_GONE;
  }
  UpdateData( FALSE );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::DecryptVersion( void )
{
  HIVER[ 0 ] = (char) (HIVER[ 0 ] ^ 15 );
  LOVER[ 0 ] = (char) (LOVER[ 0 ] - 8 );
  LOVER[ 1 ] = (char) (LOVER[ 1 ] ^ 177 );
  BUILD[ 0 ] = (char) (BUILD[ 0 ] + 24 );
  BUILD[ 1 ] = (char) (BUILD[ 1 ] - 11 );
  BUILD[ 2 ] = (char) (BUILD[ 2 ] ^ 143 );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OpenSockets( void )
{
  if ( ReceivingSock.Create( INPORT, SOCK_DGRAM, FD_WRITE | FD_READ | FD_ACCEPT | FD_CONNECT ) == 0 )
  {
    if ( Language == US ) MessageBox( "Can't create receiving socket (possibly a 2nd copy of program is present).\nProgram can't continue.", "LANChat 4.0", MB_OK );
    else MessageBox( "Nie mog wysya informacji do sieci. Program nie moe zosta uruchomiony.", "LANChat 4.0", MB_OK );
    this->EndDialog( -1 );
    SecondCopy = 1;
  }
  if ( ( SendingSock.Create( OUTPORT, SOCK_DGRAM, FD_WRITE | FD_READ | FD_ACCEPT | FD_CONNECT ) == 0 ) && ( SecondCopy == 0 ) )
  {
    if ( Language == US ) MessageBox( "Can't create sending socket.\nProgram can't continue.", "LANChat 4.0", MB_OK );
    else MessageBox( "Nie odbieram informacji z sieci. Program nie moe zosta uruchomiony.", "LANChat 4.0", MB_OK );
    this->EndDialog( -1 );
    SecondCopy = 1;
  }

  int abuf = 4090;
  SendingSock.SetSockOpt( SO_BROADCAST, &Truth, sizeof( Truth ) );
  ReceivingSock.SetSockOpt( SO_BROADCAST, &Truth, sizeof( Truth ) );
  SendingSock.SetSockOpt( SO_SNDBUF, &abuf, sizeof( abuf ) );
  ReceivingSock.SetSockOpt( SO_RCVBUF, &abuf, sizeof( abuf ) );
  ReceivingSock.SetSockOpt( SO_SNDBUF, &abuf, sizeof( abuf ) );
  SendingSock.SetSockOpt( SO_RCVBUF, &abuf, sizeof( abuf ) );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::InitDialogs( void )
{
  // topic dialog
  TopicDialog=new class CTopicDlg;
  TopicDialog->Language = (char) Language;
  TopicDialog->Bytes = 0;
  TopicDialog->ChatMessages = 0;
  TopicDialog->TotalMessages = 0;
  TopicDialog->Create( IDD_TOPIC, NULL );
  TopicDialog->ShowWindow( SW_HIDE );
  TopicDialog->tCh = 0;
  TopicDialog->Owner = this;

  // setup dialog
  SetupDialog = new CSetupDlg;
  SetupDialog->Owner = this;
  SetupDialog->Language = (char) Language;
  SetupDialog->Create( IDD_SETUP, NULL );
  SetupDialog->ShowWindow( SW_HIDE );
  SetupDialog->nCg = 0;
  SetupDialog->q = 1;

  // users dialog
  UsersDialog=new CUsersDlg;
  UsersDialog->Create( IDD_USERS, NULL );
  if ( Language != US ) UsersDialog->SetWindowText( "Aktywni uytkownicy" );

  // about dialog
  AboutDialog=new CAboutDlg;
  AboutDialog->Create( IDD_CREDITS, NULL );
  AboutDialog->ShowWindow( SW_HIDE );

  // away dialog
  AwayDialog = new CAwayDlg;
  AwayDialog->Owner = this;

  // popup dialog
  PopUpDialog = new CPopUpDlg;
  PopUpDialog->Owner = this;
}

/////////////////////////////////////////////////////////////////////////////

BOOL CLANChatDlg::OnInitDialog()
{
  char host[ 30 ];

  aUsers = 0;
  Mordy.Create( IDB_USERLIST, 16, 1, RGB( 255, 255, 255 ) );
  m_Users.DeleteColumn( 0 );
  m_Users.DeleteColumn( 1 );
  m_Users.SetImageList( &Mordy, LVSIL_SMALL );
  m_Users.InsertColumn( 1, "Users", LVCFMT_LEFT, 100 );
  Menu = new CMenu;
  if (Language==US) Menu->LoadMenu(IDR_POPUP);
  else Menu->LoadMenu(IDR_POPUP_PL);

  for ( int qer = 0; qer <= 255; qer++ )
  {
    CryptType[ qer ] = CRYPT_DEFAULT;
    Words[ qer ] = 0;
    Chars[ qer ] = 0;
    CHO[ qer ] = 0;
  }

  SnifProt = 0;
  Reg = 1;
  ActDlg = 1;
  StillAlive = 1;
  NetAlive = 1;
  gethostname( host, 30 );
  pHostEnt = gethostbyname( host );
  MyIP = *( pHostEnt->h_addr + 3 );
  m_Mute = 0;
  srand( ( unsigned ) time( NULL ) );

  InitDialogs();
  ReadConfig();

  for ( int f = 0; f < 255; f++ )
  {
    PChat[ f ] = NULL;
    Said[ f ] = 0;
  }

  CDialog::OnInitDialog();
  WndStatus = 1;

  DecryptVersion();
  OpenSockets();
  if ( SecondCopy == 0 ) SetNotifyIcon();
  SetIcon( m_hIcon, TRUE );
  SetIcon( m_hIcon, FALSE );

  if ( Minimized == 1 ) Minimize(); else UstawWielkosc();

  if ( Language == US )
  {
    Kolor( 64, 64, 64 );
    wsprintf( welcome, "Welcome to LANChat %s.%s (build %s) by GORO\nAll Rights Reserved.\nType /help for commands summary.\n", HIVER, LOVER, BUILD );
    AddText( 64, 64, 64, welcome, 0, 0 );
    wsprintf( welcome, "http://www.lanchat.topnet.pl\n\n" );
    AddText( 64, 64, 64, welcome, 0, 0 );
  }
  else
  {
    Kolor( 64, 64, 64 );
    wsprintf( welcome, "Witaj w programie LANChat %s.%s (build %s)\n(c) GORO - wszelkie prawa zastrzeone.\nWpisz /help by uzyska list komend.\n", HIVER, LOVER, BUILD );
    AddText( 64, 64, 64, welcome, 0, 0 );
    wsprintf( welcome, "http://www.lanchat.topnet.pl\n\n" );
    AddText( 64, 64, 64, welcome, 0, 0 );
  }

  if ( SetupDialog->Logging == 1 )
  {
    plik = fopen( SetupDialog->LongLogFile, "a+b" );
    if ( Language == US ) wsprintf( message, "LANChat started: %02d:%02d:%02d\n", Czas.wHour, Czas.wMinute, Czas.wSecond );
    else wsprintf( message, "LANChat rozpoczty: %02d:%02d:%02d\n", Czas.wHour, Czas.wMinute, Czas.wSecond );
    if ( plik != NULL ) fputs( message, plik );
    if ( plik != NULL ) fclose( plik );
  }

  wsprintf( Start, "%02d:%02d:%02d", Czas.wHour, Czas.wMinute, Czas.wSecond );
  strcpy( TopicDialog->cTopic, "<>" );
  strcpy( TopicDialog->Time, "" );
  strcpy( TopicDialog->Start, Start );

  for ( int n = 0; n < 256; n++ ) LAGs[ n ] = 0;
  SetTimer( 1, LAG, NULL );
  SetTimer( 2, AUTOALIVE, NULL );

  AwBut.LoadBitmaps( IDB_NOT_AWAY, IDB_AWAY, 0, 0 );
  VERIFY( AwBut.SubclassDlgItem( IDC_CHECK1, this ) );
  AwBut.SizeToContent();
  SndBut.LoadBitmaps( IDB_SND_ON, IDB_SND_OFF, 0, 0 );
  VERIFY( SndBut.SubclassDlgItem( IDC_CHECK2, this ) );
  SndBut.SizeToContent();
  MsgBut.LoadBitmaps( IDB_MSG_OFF, 0, 0, 0 );
  VERIFY( MsgBut.SubclassDlgItem( IDC_MSG, this ) );
  MsgBut.SizeToContent();
  SetupBut.LoadBitmaps( IDB_SETUP, IDB__SETUP, 0, 0 );
  VERIFY( SetupBut.SubclassDlgItem( IDC_BSETUP, this ) );
  SetupBut.SizeToContent();
  AboutBut.LoadBitmaps( IDB_ABOUT, IDB__ABOUT, 0, 0 );
  VERIFY( AboutBut.SubclassDlgItem( IDC_BABOUT, this ) );
  AboutBut.SizeToContent();
  TopicBut.LoadBitmaps( IDB_TOPIC, IDB__TOPIC, 0, 0 );
  VERIFY( TopicBut.SubclassDlgItem( IDC_BTOPIC, this ) );
  TopicBut.SizeToContent();
  MinBut.LoadBitmaps( IDB_MIN, IDB__MIN, 0, 0 );
  VERIFY( MinBut.SubclassDlgItem( IDC_MIN, this ) );
  MinBut.SizeToContent();
  ClsBut.LoadBitmaps( IDB_CLS, IDB__CLS, 0, 0 );
  VERIFY( ClsBut.SubclassDlgItem( IDC_MOTH, this ) );
  ClsBut.SizeToContent();
  StatBut.LoadBitmaps( IDB_STATUS, IDB__STATUS, 0, 0 );
  VERIFY( StatBut.SubclassDlgItem( IDC_STATUSEX, this ) );
  StatBut.SizeToContent();

  SetupDialog->q = 0;

  UpdateData( FALSE );
  return TRUE;
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnPaint()
{
  if ( IsIconic() )
  {
    CPaintDC dc( this );
    SendMessage( WM_ICONERASEBKGND, ( WPARAM ) dc.GetSafeHdc(), 0 );
    int cxIcon = GetSystemMetrics( SM_CXICON );
    int cyIcon = GetSystemMetrics( SM_CYICON );
    CRect rect;
    GetClientRect( &rect );
    int x = ( rect.Width() - cxIcon + 1 ) / 2;
    int y = ( rect.Height() - cyIcon + 1 ) / 2;
    dc.DrawIcon( x, y, m_hIcon );
  }
  else
  {
    CDialog::OnPaint();
  }
}

/////////////////////////////////////////////////////////////////////////////

HCURSOR CLANChatDlg::OnQueryDragIcon()
{
  return ( HCURSOR ) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::DeInit()
{
  if ( ActDlg == 1 )
  {
    if ( StillAlive == 1 )
    {
      delete Menu;
      if ( SecondCopy == 0 ) SendLCMsg( LC_LEAVE, LC_BROADCAST, "\0" );
      KillTimer( 1 );
      KillTimer( 2 );
      SendingSock.Close();
      ReceivingSock.Close();
      Shell_NotifyIcon( NIM_DELETE, &NotifyIcon );

      GetLocalTime( &Czas );
      if ( SetupDialog->Logging == 1 )
      {
        if ( Language == US )
        {
          plik = fopen( SetupDialog->LongLogFile, "a+b" );
          wsprintf( message, "Session closed.\n" );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "Bytes received: %u\n", TopicDialog->Bytes );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "Chat messages: %u\n", TopicDialog->ChatMessages );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "Total messages: %u\n", TopicDialog->TotalMessages );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "LANChat ended: %02d:%02d:%02d\n=============\n", Czas.wHour, Czas.wMinute, Czas.wSecond );
          if ( plik != NULL ) fputs( message, plik );
          if ( plik != NULL ) fclose( plik );
        }
        else
        {
          plik = fopen( SetupDialog->LongLogFile, "a+b" );
          wsprintf( message, "Sesja zamknita.\n" );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "Bajtw odebranych: %u\n", TopicDialog->Bytes );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "Komunikatw przesanych: %u\n", TopicDialog->ChatMessages );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "Wszystkich pakietw: %u\n", TopicDialog->TotalMessages );
          if ( plik != NULL ) fputs( message, plik );
          wsprintf( message, "LANChat zakoczony: %02d:%02d:%02d\n=============\n", Czas.wHour, Czas.wMinute, Czas.wSecond );
          if ( plik != NULL ) fputs( message, plik );
          if ( plik != NULL ) fclose( plik );
        }
      }

      WindowPlcmnt.length = sizeof( WindowPlcmnt );
      GetWindowPlacement( &WindowPlcmnt );
      SetupDialog->left = WindowPlcmnt.rcNormalPosition.left;
      SetupDialog->top = WindowPlcmnt.rcNormalPosition.top;

      WriteConfig();
          /*
      for ( int f = 0; f < 255; f++ ) if ( PChat[ f ] != NULL ) delete PChat[ f ];
          delete SetupDialog;
          delete TopicDialog;
          delete AboutDialog;
          delete AwayDialog;
          delete UsersDialog;
          delete PopUpDialog;
          delete Menu;
          */
      StillAlive = 0;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnClose()
{
  CDialog::OnClose();
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnOK()
{
  DeInit();
  CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////

BOOL CLANChatDlg::DestroyWindow()
{
  DeInit();
  return CDialog::DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnStatusEx()
{
  UsersDialog->Clear();
  SendLCMsg( LC_REQ_STATUS_EX, LC_BROADCAST, "\0" );
  UsersDialog->ShowWindow( SW_NORMAL );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnClickUsers( NMHDR* pNMHDR, LRESULT* pResult )
{
  HD_NOTIFY * phdn = ( HD_NOTIFY * ) pNMHDR;

  char nickor[ 25 ];
  int sIP;
  char ClR = 0;

  m_Users.GetItemText( phdn->iItem, 0, nickor, 25 );
  sIP = LC_BROADCAST;
  for ( int nM = 0; nM < 255; nM++ )
    if ( strcmp( nickor, Nick[ nM ] ) == 0 ) sIP = nM;
  if ( sIP != LC_BROADCAST ) SendLCMsg( LC_REQ_AWAY, sIP, "\0" );
  UpdateData( TRUE );
  *pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnDblclkUsers( NMHDR* pNMHDR, LRESULT* pResult )
{
  HD_NOTIFY * phdn = ( HD_NOTIFY * ) pNMHDR;

  char nickor[ 25 ];
  int sIP;
  char ClR = 0;

  m_Users.GetItemText( phdn->iItem, 0, nickor, 25 );
  sIP = LC_BROADCAST;
  for ( int nM = 0; nM < 255; nM++ )
    if ( strcmp( nickor, Nick[ nM ] ) == 0 ) sIP = nM;
  UpdateData( TRUE );

  if ( ( sIP != MyIP ) && ( sIP != LC_BROADCAST ) )
  {
    {
      PChat[ sIP ] ->ShowWindow( SW_SHOW );
      PChat[ sIP ] ->SetDefID( IDC_PSEND );
      PChat[ sIP ] ->Max = 1;
      Said[ sIP ] = 0;
      UpdateList();
    }
  }
  *pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////

BOOL CLANChatDlg::PreTranslateMessage( MSG* pMsg )
{
  if ( ( pMsg->message == WM_COMMAND ) && ( pMsg->wParam==ID_MENU_EXIT) )
    CDialog::OnCancel();

  if ( ( pMsg->message == WM_COMMAND ) && ( pMsg->wParam==ID_MENU_SETUP) )
    OnSetup();

  if ( ( pMsg->message == WM_COMMAND ) && ( pMsg->wParam==ID_RESTORE) )
        SendMessage(WM_TRAY,0,513);

  if ( ( pMsg->message == WM_COMMAND ) && ( pMsg->wParam==ID_MENU_ABOUT) )
    OnAbout();

  if ( ( pMsg->message == WM_SYSKEYDOWN ) && ( pMsg->wParam == 112 ) )
  {
    UpdateData( TRUE );
    m_Wpis += SetupDialog->Short->m_Sh1;
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
    if (m_Wpis.GetAt(m_Wpis.GetLength()-1)=='@')
    {
      m_Wpis.SetAt(m_Wpis.GetLength()-1,' ');
      UpdateData( FALSE );
      OnSendMsg();
    }
  }
  if ( ( pMsg->message == WM_SYSKEYDOWN ) && ( pMsg->wParam == 113 ) )
  {
    UpdateData( TRUE );
    m_Wpis += SetupDialog->Short->m_Sh2;
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
    if (m_Wpis.GetAt(m_Wpis.GetLength()-1)=='@')
    {
      m_Wpis.SetAt(m_Wpis.GetLength()-1,' ');
      UpdateData( FALSE );
      OnSendMsg();
    }
  }
  if ( ( pMsg->message == WM_SYSKEYDOWN ) && ( pMsg->wParam == 114 ) )
  {
    UpdateData( TRUE );
    m_Wpis += SetupDialog->Short->m_Sh3;
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
    if (m_Wpis.GetAt(m_Wpis.GetLength()-1)=='@')
    {
      m_Wpis.SetAt(m_Wpis.GetLength()-1,' ');
      UpdateData( FALSE );
      OnSendMsg();
    }
  }

  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 38 ) )
  {

    m_Wpis = OldText;
    if (m_Wpis.GetAt(m_Wpis.GetLength()-1)!=' ') m_Wpis += ' ';
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_WPISYWANIE, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
  }

  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 116 ) ) OnMin();
  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 120 ) ) OnMotherAttack();

  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 113 ) ) OnAbout();
  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 114 ) ) OnTopic();
  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 115 ) ) OnSetup();

  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 118 ) ) OnCheckMute();
  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 119 ) ) OnStatusEx();

  if ( ( pMsg->message == WM_KEYDOWN ) && ( pMsg->wParam == 117 ) )
  {
    UpdateData( TRUE );
    OnCheckAway();
  }
  return CDialog::PreTranslateMessage( pMsg );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::WinHelp( DWORD dwData, UINT nCmd )
{
  if ( Language == US ) MessageBox( "No run-time help available!\n\nPlease read LANChat documentation in HTML files supported with the program file.", "LANChat 4.0", MB_ICONEXCLAMATION | MB_OK );
  else MessageBox( "Brak wbudowanej pomocy!\n\nProsz przeczyta dokumentacj w formacie HTML zaczon do programu.", "LANChat 4.0", MB_ICONEXCLAMATION | MB_OK );
  nCmd;
  dwData;
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::ReadConfig( void )
{
  HKEY hRegKey;
  DWORD first;
  char temp[ 80 ];
  char s1t[ 80 ], s2t[ 80 ], s3t[ 80 ];
  unsigned long S;
  char Acceptable = 1;

  // here are the defaults
  strcpy( temp, "Guest" );
  strcpy( s1t, "" );
  strcpy( s2t, "" );
  strcpy( s3t, "" );
  strcpy( SetupDialog->LogDir, "logs" );
  SetupDialog->m_R = 100; SetupDialog->m_G = 100; SetupDialog->m_B = 100;
  SetupDialog->Logging = 1;
  SetupDialog->PopMode = 2;
  Language = US;
  AutoShow = 1;
  SetupDialog->m_SoundCard = 1;
  SetupDialog->msgtime = 0;
  SetupDialog->snicks = 1;
  SetupDialog->spnicks = 0;
  SetupDialog->left = -1;
  SetupDialog->top = -1;
  SetupDialog->Female = FALSE;
  SetupDialog->adv = 0;

  RegCreateKeyEx( HKEY_CURRENT_USER, "SOFTWARE\\LANChat", 0,
                  NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
                  NULL, &hRegKey, &first );

  memset(&SetupDialog->Font,0,sizeof(LOGFONT));

  if ( first == REG_CREATED_NEW_KEY )
    MessageBox( "\tWelcome to LANChat 4.0 !\n\nSince this is your first use of this program please click the Setup Icon (or hit F4)\nand set your favourite options in LANChat.", "LANChat 4.0", MB_OK | MB_ICONINFORMATION );

  S = 80; RegQueryValueEx( hRegKey, "LogDir", NULL, NULL, ( unsigned char * ) SetupDialog->LogDir, &S );
  S = 4; RegQueryValueEx( hRegKey, "ColorR", NULL, NULL, ( unsigned char * ) & SetupDialog->m_R, &S );
  S = 4; RegQueryValueEx( hRegKey, "ColorG", NULL, NULL, ( unsigned char * ) & SetupDialog->m_G, &S );
  S = 4; RegQueryValueEx( hRegKey, "ColorB", NULL, NULL, ( unsigned char * ) & SetupDialog->m_B, &S );
  S = 2; RegQueryValueEx( hRegKey, "Logging", NULL, NULL, ( unsigned char * ) & SetupDialog->Logging, &S );
  S = 2; RegQueryValueEx( hRegKey, "PopMode", NULL, NULL, ( unsigned char * ) & SetupDialog->PopMode, &S );
  S = 4; RegQueryValueEx( hRegKey, "Language", NULL, NULL, ( unsigned char * ) & Language, &S );
  S = 2; RegQueryValueEx( hRegKey, "AutoShow", NULL, NULL, ( unsigned char * ) & AutoShow, &S );
  S = 2; RegQueryValueEx( hRegKey, "SoundCard", NULL, NULL, ( unsigned char * ) & SetupDialog->m_SoundCard, &S );
  S = 2; RegQueryValueEx( hRegKey, "ShowMsgTime", NULL, NULL, ( unsigned char * ) & SetupDialog->msgtime, &S );
  S = 2; RegQueryValueEx( hRegKey, "ShowNicks", NULL, NULL, ( unsigned char * ) & SetupDialog->snicks, &S );
  S = 2; RegQueryValueEx( hRegKey, "ShowPNicks", NULL, NULL, ( unsigned char * ) & SetupDialog->spnicks, &S );
  S = 4; RegQueryValueEx( hRegKey, "Left", NULL, NULL, ( unsigned char * ) & SetupDialog->left, &S );
  S = 4; RegQueryValueEx( hRegKey, "Female", NULL, NULL, ( unsigned char * ) & SetupDialog->Female, &S );
  S = 4; RegQueryValueEx( hRegKey, "Adv", NULL, NULL, ( unsigned char * ) & SetupDialog->adv, &S );
  S = sizeof(LOGFONT); RegQueryValueEx( hRegKey, "Font", NULL, NULL, ( unsigned char * ) & SetupDialog->Font, &S );
  S = 80; RegQueryValueEx( hRegKey, "Sh1", NULL, NULL, ( unsigned char * ) s1t, &S );
  SetupDialog->Short->m_Sh1 = s1t;
  S = 80; RegQueryValueEx( hRegKey, "Sh2", NULL, NULL, ( unsigned char * ) s2t, &S );
  SetupDialog->Short->m_Sh2 = s2t;
  S = 80; RegQueryValueEx( hRegKey, "Sh3", NULL, NULL, ( unsigned char * ) s3t, &S );
  SetupDialog->Short->m_Sh3 = s3t;

  S = 80;
  RegQueryValueEx( hRegKey, "Nick", NULL, NULL, ( unsigned char * ) temp, &S );

  if ( strlen( temp ) > 19 ) Acceptable = 0;
  if ( strlen( temp ) < 3 ) Acceptable = 0;
  if ( Acceptable == 0 )
    if ( Language == US ) MessageBox( "Bad nick. Using default.", "LANChat 4.0", MB_OK );
    else MessageBox( "Zy pseudonim. Uywam standardowego.", "LANChat 4.0", MB_OK );
  if ( ( strcmp( temp, "Guest" ) == 0 ) || ( Acceptable == 0 ) ) wsprintf( temp, "Guest.%d", MyIP );
  temp[ 20 ] = '\0';
  SetupDialog->m_Nick = temp;

  GetLocalTime( &Czas );
  wsprintf( SetupDialog->LogFile, "%02d%02d%02d.log", Czas.wYear, Czas.wMonth, Czas.wDay );
  strcpy( SetupDialog->LongLogFile, SetupDialog->LogDir );
  if ( SetupDialog->LongLogFile[ strlen( SetupDialog->LongLogFile ) ] != '\\' ) strcat( SetupDialog->LongLogFile, "\\" );
  strcat( SetupDialog->LongLogFile, SetupDialog->LogFile );
  if ( ( SetupDialog->Logging < 0 ) || ( SetupDialog->Logging > 1 ) ) SetupDialog->Logging = 1;
  if ( ( SetupDialog->snicks < 0 ) || ( SetupDialog->snicks > 1 ) ) SetupDialog->snicks = 1;
  if ( ( SetupDialog->spnicks < 0 ) || ( SetupDialog->spnicks > 1 ) ) SetupDialog->spnicks = 1;
  if ( ( SetupDialog->msgtime < 0 ) || ( SetupDialog->msgtime > 1 ) ) SetupDialog->msgtime = 0;
  if ( ( SetupDialog->m_SoundCard < 0 ) || ( SetupDialog->m_SoundCard > 1 ) ) SetupDialog->m_SoundCard = 1;
  if ( SetupDialog->m_R > 255 ) SetupDialog->m_R = 255;
  if ( SetupDialog->m_G > 255 ) SetupDialog->m_G = 255;
  if ( SetupDialog->m_B > 255 ) SetupDialog->m_B = 255;
  if ( SetupDialog->m_R < 0 ) SetupDialog->m_R = 0;
  if ( SetupDialog->m_G < 0 ) SetupDialog->m_G = 0;
  if ( SetupDialog->m_B < 0 ) SetupDialog->m_B = 0;
  if ( ( SetupDialog->left < 5 ) && ( SetupDialog->left != -1 ) ) SetupDialog->left = 5;
  if ( ( SetupDialog->top < 5 ) && ( SetupDialog->top != -1 ) ) SetupDialog->top = 5;
  if ( SetupDialog->left > GetSystemMetrics( SM_CXFULLSCREEN ) - 5 ) SetupDialog->left = GetSystemMetrics( SM_CXFULLSCREEN ) - 5;
  if ( SetupDialog->top > GetSystemMetrics( SM_CYFULLSCREEN ) - 5 ) SetupDialog->top = GetSystemMetrics( SM_CYFULLSCREEN ) - 5;
  if ( SetupDialog->left == -1 ) SetupDialog->left = GetSystemMetrics( SM_CXFULLSCREEN ) / 2 - 247;
  if ( SetupDialog->top == -1 ) SetupDialog->top = GetSystemMetrics( SM_CYFULLSCREEN ) / 2 - 175;

  if (*((unsigned char *)&SetupDialog->Font)!=0) SetFonts();

  RegCloseKey( hRegKey );
  WriteConfig();

}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::WriteConfig( void )
{
  HKEY hRegKey;
  DWORD first;

  RegCreateKeyEx( HKEY_CURRENT_USER, "SOFTWARE\\LANChat", 0,
                  NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
                  NULL, &hRegKey, &first );

  RegSetValueEx( hRegKey, "Nick", 0, REG_SZ, ( unsigned char * ) ( LPCSTR( SetupDialog->m_Nick ) ), SetupDialog->m_Nick.GetLength() );
  RegSetValueEx( hRegKey, "ColorR", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->m_R, sizeof( SetupDialog->m_R ) );
  RegSetValueEx( hRegKey, "ColorG", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->m_G, sizeof( SetupDialog->m_G ) );
  RegSetValueEx( hRegKey, "ColorB", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->m_B, sizeof( SetupDialog->m_B ) );
  RegSetValueEx( hRegKey, "Logging", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->Logging, sizeof( SetupDialog->Logging ) );
  RegSetValueEx( hRegKey, "PopMode", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->PopMode, sizeof( SetupDialog->PopMode ) );
  RegSetValueEx( hRegKey, "LogDir", 0, REG_SZ, ( unsigned char * ) ( SetupDialog->LogDir ), strlen( SetupDialog->LogDir ) );
  RegSetValueEx( hRegKey, "Language", 0, REG_DWORD, ( unsigned char * ) & Language, sizeof( Language ) );
  RegSetValueEx( hRegKey, "AutoShow", 0, REG_DWORD, ( unsigned char * ) & AutoShow, sizeof( AutoShow ) );
  RegSetValueEx( hRegKey, "SoundCard", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->m_SoundCard, sizeof( SetupDialog->m_SoundCard ) );
  RegSetValueEx( hRegKey, "ShowMsgTime", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->msgtime, sizeof( SetupDialog->msgtime ) );
  RegSetValueEx( hRegKey, "ShowNicks", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->snicks, sizeof( SetupDialog->snicks ) );
  RegSetValueEx( hRegKey, "ShowPNicks", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->spnicks, sizeof( SetupDialog->spnicks ) );
  RegSetValueEx( hRegKey, "Left", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->left, sizeof( SetupDialog->left ) );
  RegSetValueEx( hRegKey, "Top", 0, REG_DWORD, ( unsigned char * ) & SetupDialog->top, sizeof( SetupDialog->top ) );
  RegSetValueEx( hRegKey, "Sh1", 0, REG_SZ, ( unsigned char * ) ( LPCSTR( SetupDialog->Short->m_Sh1 ) ), SetupDialog->Short->m_Sh1.GetLength() );
  RegSetValueEx( hRegKey, "Sh2", 0, REG_SZ, ( unsigned char * ) ( LPCSTR( SetupDialog->Short->m_Sh2 ) ), SetupDialog->Short->m_Sh2.GetLength() );
  RegSetValueEx( hRegKey, "Sh3", 0, REG_SZ, ( unsigned char * ) ( LPCSTR( SetupDialog->Short->m_Sh3 ) ), SetupDialog->Short->m_Sh3.GetLength() );
  RegSetValueEx( hRegKey, "Font", 0, REG_BINARY, ( unsigned char * ) &SetupDialog->Font, sizeof(LOGFONT));
  RegSetValueEx( hRegKey, "Female", 0, REG_DWORD, ( unsigned char * ) &SetupDialog->Female, sizeof(BOOL));
  RegSetValueEx( hRegKey, "Adv", 0, REG_DWORD, ( unsigned char * ) &SetupDialog->adv, sizeof(BOOL));
  RegCloseKey( hRegKey );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::SetFonts(void)
{
  CFont *cf=new CFont;
  cf->CreateFontIndirect(&SetupDialog->Font);
  SendDlgItemMessage(IDC_CHATBOX,WM_SETFONT,(WPARAM)HFONT(*cf),1);
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::Bolden( void )
{
  nTextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  nTextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) nTextLength, ( LPARAM ) nTextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_GETCHARFORMAT, 0, ( LPARAM ) & CHFormat );
  CHFormat.cbSize = sizeof( CHFormat );
  CHFormat.dwEffects = CFE_BOLD;
  CHFormat.dwMask = CFM_BOLD;
  SendDlgItemMessage( IDC_CHATBOX, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & CHFormat );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::Unbolden( void )
{
  nTextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  nTextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) nTextLength, ( LPARAM ) nTextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_GETCHARFORMAT, 0, ( LPARAM ) & CHFormat );
  CHFormat.cbSize = sizeof( CHFormat );
  CHFormat.dwEffects = 0;
  CHFormat.dwMask = CFM_BOLD;
  SendDlgItemMessage( IDC_CHATBOX, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & CHFormat );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::Kolor( int r, int g, int b )
{
  nTextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  nTextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) nTextLength, ( LPARAM ) nTextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_GETCHARFORMAT, 0, ( LPARAM ) & CHFormat );
  CHFormat.cbSize = sizeof( CHFormat );
  CHFormat.crTextColor = RGB( r, g, b );
  CHFormat.dwEffects = 0;
  CHFormat.dwMask = CFM_COLOR;
  SendDlgItemMessage( IDC_CHATBOX, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & CHFormat );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::AddText( int r, int g, int b, char *txt, char bolden = 0, char Logable = 1 )
{
  if ( ( Logable == 0 ) || ( Logable == 1 ) )
  {
    if ( bolden == 1 ) Bolden(); else Unbolden();
    Kolor( r, g, b );
    nTextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
    nTextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) nTextLength, ( LPARAM ) nTextLength );
    SendDlgItemMessage( IDC_CHATBOX, EM_REPLACESEL, ( WPARAM ) FALSE, ( LPARAM ) txt );
    SendDlgItemMessage( IDC_CHATBOX, EM_SCROLLCARET, 0, 0 );
    Unbolden();

    if ( SetupDialog->q == 0 )
    {
      if ( ( WndStatus == 0 ) && ( m_Mute == FALSE ) ) MessageBeep( 0xFFFFFFFF );
      if ( WndStatus == 0 ) WarnIcon();
    }
  }
  if ( ( ( SetupDialog->Logging == 1 ) && ( Logable != 0 ) ) )
  {
    plik = fopen( SetupDialog->LongLogFile, "a+b" );
    if ( plik != NULL ) fputs( txt, plik );
    if ( plik != NULL ) fclose( plik );
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::UpdateList( void )
{
  m_Users.DeleteAllItems();
  m_Users.DeleteColumn( 0 );
  m_Users.DeleteColumn( 1 );
  m_Users.SetImageList( &Mordy, LVSIL_SMALL );
  m_Users.InsertColumn( 1, "Users", LVCFMT_LEFT, 90 );

  aUsers = 0;
  CountLAG();

  for ( int n = 0; n < 256; n++ )
  {
    switch ( Status[ n ] )
    {
    case USER_PRESENT:
      {
        char dummy[ 30 ];
        wsprintf(dummy,"%s",Nick[n]);
        if (Said[n]==0) m_Users.InsertItem( aUsers++, dummy, 0 );
        else m_Users.InsertItem( aUsers++, dummy, 2 );
      }
      break;
    case USER_AWAY:
      {
        char dummy[ 30 ];
        wsprintf(dummy,"%s",Nick[n]);
        if (Said[n]==0) m_Users.InsertItem( aUsers++, dummy, 1 );
        else m_Users.InsertItem( aUsers++, dummy, 3 );
      }
      break;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnMotherAttack()
{
  SendLCMsg( LC_MOTHER, LC_BROADCAST, "\0" );
  SetDlgItemText( IDC_CHATBOX, "" );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnCheckAway()
{
  char LCG[32][80]={"Despite all my rage...",
                    "Love is suicide!",
                    "Toworrow is just an excuse away.",
                    "Army of Me.",
                    "It's the little things that kill.",
                    "This confusion is my illusion.",
                    "Who cares?",
                    "Just ask me!",
                    "What did you expect to read here?",
                    "Live to ride, ride to live.",
                    "Mind your own business!",
                    "LANChat - Just do it.",
                    "LANChat - a modern client for a old world.",
                    "LANChat - the Cadillac of all clients.",
                    "LANChat - born to raise hell.",
                    "LANChat - a new fragrance for men, by Calvin Klein.",
                    "LANChat - don't leave home without it!",
                    "LANChat - double your pleasure, double your fun!",
                    "LANChat - anything else would be uncivilized.",
                    "LANChat - to the rescue!",
                    "LANChat - do it the right away.",
                    "LANChat - the fresh-maker!",
                    "LANChat - its YOUR planet.",
                    "LANChat - try to face it.",
                    "For a good time, call 0-700-LANCHAT",
                    "The Power Rangers use LANChat Shouldn't you?",
                    "Tony the Tiger uses LANChat. Its Grrrrrrrrreat!",
                    "What you have to do today do after tomorrow - you'll have two days off!",
                    "My intelligence is not able to write anything here.",
                    "Didn't you know ? Quake is a LANChat-based game.",
                    "Even Caesar used LANChat.",
                    "Kevin Mitnick had LANChat on his desktop."};

  m_Away = (char) (1 - m_Away);
  if ( m_Away == 1 ) AwBut.LoadBitmaps( IDB_AWAY, IDB_NOT_AWAY, 0, 0 );
  else AwBut.LoadBitmaps( IDB_NOT_AWAY, IDB_AWAY, 0, 0 );
  VERIFY( AwBut.SubclassDlgItem( IDC_CHECK1, this ) );
  AwBut.SizeToContent();
  AwBut.UpdateWindow();
  AwBut.RedrawWindow();
  UpdateData( TRUE );
  if ( m_Away == TRUE )
  {
    srand( (unsigned)time( NULL ) );
    SendDlgItemMessage( IDC_WPISYWANIE, EM_SETREADONLY, TRUE, 0 );
    if ( m_Wpis.IsEmpty() == TRUE )
    {
      AwayDialog->m_WhyAway = "";
      if ( AwayDialog->DoModal() == IDOK )
      {
        m_Wpis = AwayDialog->m_WhyAway;
        UpdateData( FALSE );
      }
      else
      {
        m_Away = (char) (1 - m_Away);
        AwBut.LoadBitmaps( IDB_NOT_AWAY, IDB_AWAY, 0, 0 );
        VERIFY( AwBut.SubclassDlgItem( IDC_CHECK1, this ) );
        AwBut.SizeToContent();
        AwBut.UpdateWindow();
        AwBut.RedrawWindow();
        SendDlgItemMessage( IDC_WPISYWANIE, EM_SETREADONLY, FALSE, 0 );
        return;
      }
      if ( m_Wpis.IsEmpty() == TRUE ) m_Wpis = LCG[rand()%32];
    }
    SendLCMsg( LC_START_AWAY, LC_BROADCAST, LPCTSTR( m_Wpis ) );
    GetLocalTime( &Czas );
    char mes[ 30 ];
    wsprintf( mes, " (%02d:%02d:%02d)", Czas.wHour, Czas.wMinute, Czas.wSecond );
    m_Wpis += mes;
  }
  else
  {
    SendDlgItemMessage( IDC_WPISYWANIE, EM_SETREADONLY, FALSE, 0 );
    SendLCMsg( LC_END_AWAY, LC_BROADCAST, "\0" );
    m_Wpis.Empty();
  }
  UpdateData( FALSE );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnDestroy()
{
  DeInit();
  CDialog::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnCheckMute()
{
  m_Mute = (char) (1 - m_Mute);
  if ( m_Mute == 1 ) SndBut.LoadBitmaps( IDB_SND_OFF, IDB_SND_ON, 0, 0 );
  else SndBut.LoadBitmaps( IDB_SND_ON, IDB_SND_OFF, 0, 0 );
  VERIFY( SndBut.SubclassDlgItem( IDC_CHECK2, this ) );
  SndBut.SizeToContent();
  SndBut.UpdateWindow();
  SndBut.RedrawWindow();
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnSetup()
{
  SetupDialog->ShowWindow( SW_SHOWNORMAL );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnTopic()
{
  strcpy( TopicDialog->pTopic, TopicDialog->cTopic );
  TopicDialog->ShowWindow( SW_SHOWNORMAL );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnAbout()
{
  AboutDialog->ShowWindow( SW_SHOWNORMAL );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnMin()
{
  WindowPlcmnt.length = sizeof( WindowPlcmnt );
  GetWindowPlacement( &WindowPlcmnt );
  WindowPlcmnt.showCmd = SW_HIDE;
  WindowPlcmnt.length = sizeof( WindowPlcmnt );
  SetWindowPlacement( &WindowPlcmnt );
  WndStatus = 0;
}

/////////////////////////////////////////////////////////////////////////////

#define ADD AddText(64,64,64,welcome,0,0)

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::SecretMessage( void )
{
  AddText( 0, 64, 128, "That's right :)\n", 0, 0 );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::Credits( void )
{
  if ( Language == US )
  {
    AddText( 0, 0, 0, "LANChat 4.0 credits:\n", 1, 0 );
    AddText( 64, 64, 64, "Programming, graphics and ideas: ", 0, 0 );
    AddText( 128, 0, 0, "GORO", 0, 0 );
    AddText( 64, 64, 64, " <goro@vc.pl>\n" );
    AddText( 64, 64, 64, "Ideas: ", 0, 0 );
    AddText( 128, 30, 250, "Melun", 0, 0 );
    AddText( 64, 64, 64, " <melun@friko2.onet.pl>\n" );
    AddText( 64, 64, 64, "Beta testing: (everybody)\n" );
    AddText( 64, 64, 64, "Thanks to: ", 1, 0 );
    AddText( 0, 0, 0, "ABGC, AJC, Mi-V, BLADE, [:-{ and everybody I forgot!\n", 0, 0 );
    AddText( 64, 64, 64, "Send your comments to ", 0, 0 );
    AddText( 128, 0, 0, "lanchat@topnet.pl\n", 1, 0 );
    AddText( 0, 0, 0, "Visit http://www.lanchat.topnet.pl\n", 0, 0 );
    AddText( 0, 0, 0, "Enjoy !\n", 1, 0 );
  }
  else
  {
    AddText( 0, 0, 0, "Nieco o programie LANChat 4.0:\n", 1, 0 );
    AddText( 64, 64, 64, "Programowanie, grafika i pomysy: ", 0, 0 );
    AddText( 128, 0, 0, "GORO", 0, 0 );
    AddText( 64, 64, 64, " <goro@vc.pl>\n" );
    AddText( 64, 64, 64, "Dodatkowe pomysy: ", 0, 0 );
    AddText( 128, 30, 250, "Melun", 0, 0 );
    AddText( 64, 64, 64, " <melun@friko2.onet.pl>\n" );
    AddText( 64, 64, 64, "Testy beta: (wszyscy)\n" );
    AddText( 64, 64, 64, "Podzikowania dla: ", 1, 0 );
    AddText( 0, 0, 0, "ABGC, AJC, Mi-Va, BLADEa, [:-{, Cody'ego i wszystkich zsieciowanych!\n", 0, 0 );
    AddText( 64, 64, 64, "Opinie prosz sa na ", 0, 0 );
    AddText( 128, 0, 0, "lanchat@topnet.pl\n", 1, 0 );
    AddText( 0, 0, 0, "Odwied http://www.lanchat.topnet.pl\n", 0, 0 );
    AddText( 0, 0, 0, "Miego chatowania !\n", 1, 0 );
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::Help( void )
{
  if ( Language == US )
  {
    wsprintf( welcome, "Keyboard shortcuts:\n" ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "F2 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- about, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F3 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- topic, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F4 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- setup, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F5 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- minimize, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F6 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- away, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F7 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- mute on/off, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F8 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- users, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F9 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- mother-attack\n" ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "Commands:\n" ); AddText( 0, 0, 0, welcome, 1, 0 );

    Bolden(); wsprintf( welcome, "/credits " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- display credits\n" ); AddText( 64, 64, 64, welcome, 0, 0 );
    Bolden(); wsprintf( welcome, "/msg user " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- bring private window (user case-sensitive!)\n" ); AddText( 64, 64, 64, welcome, 0, 0 );
    Bolden(); wsprintf( welcome, "/me text " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- important messages\n" ); ADD;
    Bolden(); wsprintf( welcome, "/nick newnick " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- change nick (3-19 chars)\n" ); ADD;
    Bolden(); wsprintf( welcome, "/pop user text " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- send a PopUp message\n" ); ADD;
    Bolden(); wsprintf( welcome, "/min " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "or " ); ADD;
    Bolden(); wsprintf( welcome, "/m " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- hide window (main or private)\n" ); ADD;
    Bolden(); wsprintf( welcome, "/c " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- clear private text (only in private-chat)\n" ); ADD;
    if ( SetupDialog->Logging == 1 )
    {
      wsprintf( welcome, "Logging to %s\n", SetupDialog->LongLogFile );
    }
    else wsprintf( welcome, "Logging is disabled.\n" );
    AddText( 64, 64, 64, welcome, 0, 0 );
  }
  else
  {
    wsprintf( welcome, "Skrty:\n" ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "F2 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- o programie, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F3 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- temat, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F4 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- opcje, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F5 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- do paska zada, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F6 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- away, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F7 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- cisza tak/nie, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F8 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- uytkownicy, " ); AddText( 0, 0, 0, welcome, 0, 0 );
    wsprintf( welcome, "F9 " ); AddText( 0, 0, 0, welcome, 1, 0 );
    wsprintf( welcome, "- wpada matka!\n" ); AddText( 0, 0, 0, welcome, 0, 0 );
    Bolden(); wsprintf( welcome, "Komendy:\n" );
    AddText( 0, 0, 0, welcome, 1, 0 ); Unbolden();
    Bolden(); wsprintf( welcome, "/credits " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- troch o programie\n" ); AddText( 64, 64, 64, welcome, 0, 0 );
    Bolden(); wsprintf( welcome, "/msg uytkownik " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- poka rozmow prywatn\n" ); AddText( 64, 64, 64, welcome, 0, 0 );
    Bolden(); wsprintf( welcome, "/me tekst " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- wyraanie czynnoci i wanych rzeczy\n" ); ADD;
    Bolden(); wsprintf( welcome, "/nick nowa_ksywa " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- zmiana ksywki (od 3 do 19 znakw)\n" ); ADD;
    Bolden(); wsprintf( welcome, "/pop uytkownik tekst " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- wylij 'karteczk'\n" ); ADD;
    Bolden(); wsprintf( welcome, "/min " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "lub " ); ADD;
    Bolden(); wsprintf( welcome, "/m " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- ukryj okno (prywatne lub gwne)\n" ); ADD;
    Bolden(); wsprintf( welcome, "/c " ); AddText( 64, 64, 64, welcome, 1, 0 ); Unbolden();
    wsprintf( welcome, "- wyczyszczenie tekstu prywatnego (tylko w rozmowie prywatnej)\n" ); ADD;
    if ( SetupDialog->Logging == 1 )
    {
      wsprintf( welcome, "Rejestrowanie do %s\n", SetupDialog->LongLogFile );
    }
    else wsprintf( welcome, "Rejestrowanie wyczone.\n" );
    AddText( 64, 64, 64, welcome, 0, 0 );
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnSendMsg()
{
  bool tosend;

  tosend = TRUE;
  UpdateData( TRUE );
  OldText = m_Wpis;
  if ( ( m_Wpis.GetLength() > 0 ) && ( m_Away == FALSE ) )
  {

   // min
    if ( ( strcmp( m_Wpis, "/min" ) == 0 ) || ( strcmp( m_Wpis, "/m" ) == 0 ) )
    {
      m_Wpis.Empty();
      UpdateData( FALSE );
      OnMin();
      return;
    }

   // lanchatrules
    if ( strcmp( m_Wpis, "/lanchatrules" ) == 0 )
    {
      SecretMessage();
      m_Wpis.Empty();
      UpdateData( FALSE );
      return;
    }
    if ( m_Wpis[ 0 ] == '/' )
    {

     // pop
      if ( ( m_Wpis.GetLength() > 5 ) && ( m_Wpis[ 1 ] == 'p' ) &&
            ( m_Wpis[ 2 ] == 'o' ) && ( m_Wpis[ 3 ] == 'p' ) &&
            ( m_Wpis[ 4 ] == ' ' ) )
      {
        m_Wpis.SetAt( 0, ' ' );
        m_Wpis.SetAt( 1, ' ' ); m_Wpis.SetAt( 2, ' ' );
        m_Wpis.SetAt( 3, ' ' );
        m_Wpis.TrimLeft();
        m_Wpis.TrimRight();
        char towho[ 25 ];
        char mes[ 4096 ];
        int n = 0;
        int Sp = 0;
        while ( ( m_Wpis[ n ] != ' ' ) && ( m_Wpis[ n ] != '\0' ) )
        {
          towho[ Sp ] = m_Wpis[ n ];
          m_Wpis.SetAt( n, ' ' );
          n++; Sp++;
          if ( n > 22 ) break;
        }
        towho[ Sp ] = '\0';
        m_Wpis.TrimLeft();
        strcpy( mes, LPCTSTR( m_Wpis ) );
        char snt = 0;
        if ( m_Wpis.GetLength() > 0 )
        {
          for ( n = 0; n < 255; n++ )
          {
            if ( strcmp( towho, Nick[ n ] ) == 0 )
            {
              SendLCMsg( LC_POPUP, n, mes );
              snt = 1;
            }
          }
        }
        if ( snt == 0 ) if ( Language == US ) AddText( 64, 64, 64, "PopUp not sent.\n", 0, 0 ); else AddText( 64, 64, 64, "Karteczka nie zostaa odebrana.\n", 0, 0 );
      }

     // help
      if ( ( m_Wpis.GetLength() > 4 ) && ( m_Wpis[ 1 ] == 'h' ) &&
            ( m_Wpis[ 2 ] == 'e' ) && ( m_Wpis[ 3 ] == 'l' ) &&
            ( m_Wpis[ 4 ] == 'p' ) ) Help();

     // credits
      if ( ( m_Wpis.GetLength() == 8 ) && ( m_Wpis[ 1 ] == 'c' ) &&
            ( m_Wpis[ 2 ] == 'r' ) && ( m_Wpis[ 3 ] == 'e' ) && ( m_Wpis[ 4 ] == 'd' ) &&
            ( m_Wpis[ 5 ] == 'i' ) && ( m_Wpis[ 6 ] == 't' ) && ( m_Wpis[ 7 ] == 's' ) )
      {
        m_Wpis.Empty();
        Credits();
      }

     // dev's stuff
      if ( ( m_Wpis.GetLength() == 6 ) && ( m_Wpis[ 1 ] == 'd' ) &&
            ( m_Wpis[ 5 ] == '1' ) && ( m_Wpis[ 3 ] == 'v' ) &&
            ( m_Wpis[ 4 ] == '4' ) && ( m_Wpis[ 2 ] == 'e' ) )
      {
        Dev = (char) (1 - Dev);
        char mes[ 100 ];
        if ( Dev == 0 ) strcpy( mes, "D-\n" );
        else strcpy( mes, "D+\n" );
        AddText( 64, 64, 64, mes, 0, 0 );
        m_Wpis.Empty();
      }

     // dev's stuff
      if ( ( m_Wpis.GetLength() == 8 ) && ( m_Wpis[ 5 ] == 'f' ) &&
            ( m_Wpis[ 7 ] == '0' ) && ( m_Wpis[ 3 ] == 'i' ) &&
            ( m_Wpis[ 4 ] == 'f' ) && ( m_Wpis[ 1 ] == 's' ) &&
            ( m_Wpis[ 6 ] == '2' ) && ( m_Wpis[ 2 ] == 'n' ) && ( Dev == 1 ) )
      {
        Sn = (char) (1 - Sn);
        if ( Sn == 1 ) AddText( 0, 0, 0, "S+\n", 0, 0 );
        else AddText( 0, 0, 0, "S-\n", 0, 0 );
      }

     // nick
      UpdateData( TRUE );
      if ( ( m_Wpis.GetLength() > 6 ) && ( m_Wpis[ 1 ] == 'n' ) &&
            ( m_Wpis[ 2 ] == 'i' ) && ( m_Wpis[ 3 ] == 'c' ) &&
            ( m_Wpis[ 4 ] == 'k' ) && ( m_Wpis[ 5 ] == ' ' ) )
      {
        m_Wpis.SetAt( 0, ' ' ); m_Wpis.SetAt( 1, ' ' ); m_Wpis.SetAt( 2, ' ' );
        m_Wpis.SetAt( 3, ' ' ); m_Wpis.SetAt( 4, ' ' );
        m_Wpis.TrimLeft();
        m_Wpis.TrimRight();

        if ( m_Wpis.GetLength() < 3 )
        {
          if ( Language == US ) AddText( 64, 64, 64, "Bad nick!\n", 0, 0 );
          else AddText( 64, 64, 64, "Nieprawdiowa ksywa!\n", 0, 0 );
          m_Wpis.Empty();
          UpdateData( FALSE );
          return;
        }

        char Acceptable = 1;
        for ( int nM = 0; nM < 255; nM++ ) if ( strcmp( LPCTSTR( m_Wpis ), Nick[ nM ] ) == 0 ) Acceptable = 0;
          if ( Acceptable == 0 ) if ( Language == US ) AddText( 64, 64, 64, "Nick already used!\n", 0, 0 ); else AddText( 64, 64, 64, "Ksywa ju w uyciu!\n", 0, 0 );
        if ( ( m_Wpis.GetLength() > 19 ) && ( Acceptable == 1 ) )
        {
          if ( Language == US ) AddText( 64, 64, 64, "Nick too long!\n", 0, 0 ); else AddText( 64, 64, 64, "Ksywa zbyt duga!\n", 0, 0 );
          Acceptable = 0;
        }
        if ( ( m_Wpis.GetLength() < 3 ) && ( Acceptable == 1 ) )
        {
          if ( Language == US ) AddText( 64, 64, 64, "Nick too short!\n", 0, 0 ); else AddText( 64, 64, 64, "Ksywa zbyt krtka!\n", 0, 0 );
          Acceptable = 0;
        }
        if ( ( m_Wpis.GetLength() > 2 ) && ( Acceptable == 1 ) && ( m_Wpis.IsEmpty() == FALSE ) )
        {
          SetupDialog->m_Nick = m_Wpis;
          UpdateData( FALSE );
          if ( Language == US ) AddText( 64, 64, 64, "Nick changed.\n", 0, 0 ); else AddText( 64, 64, 64, "Ksywa zmieniona.\n", 0, 0 );
          strcpy( Nick[ MyIP ], LPCTSTR( SetupDialog->m_Nick ) );
          SetUser( MyIP, USER_PRESENT );
          UpdateList();
          SendLCMsg( LC_NEWNICK, LC_BROADCAST, "\0" );
        }
        m_Wpis.Empty();
      }

     // me
      if ( ( m_Wpis.GetLength() > 4 ) && ( m_Wpis[ 1 ] == 'm' ) &&
            ( m_Wpis[ 2 ] == 'e' ) && ( m_Wpis[ 3 ] == ' ' ) )
      {
        m_Wpis.SetAt( 0, ' ' ); m_Wpis.SetAt( 1, ' ' ); m_Wpis.SetAt( 2, ' ' );
        m_Wpis.TrimLeft();
        UpdateData( FALSE );
        SendLCMsg( LC_ME, LC_BROADCAST, LPCTSTR( m_Wpis ) );
        m_Wpis.Empty();
      }

     // msg
          if ( ( m_Wpis.GetLength() > 5 ) && ( m_Wpis[ 1 ] == 'm' ) &&
            ( m_Wpis[ 2 ] == 's' ) && ( m_Wpis[ 3 ] == 'g' ) &&
            ( m_Wpis[ 4 ] == ' ' ) )
      {
        m_Wpis.SetAt( 0, ' ' ); m_Wpis.SetAt( 1, ' ' ); m_Wpis.SetAt( 2, ' ' );
        m_Wpis.SetAt( 3, ' ' );
        m_Wpis.TrimLeft();
        m_Wpis.TrimRight();
        int qw = 278;
        for ( int t = 0; t < 255; t++ ) if ( strcmp( Nick[ t ], LPCTSTR( m_Wpis ) ) == 0 ) qw = t;
        if ( ( qw != 278 ) && ( PChat[ qw ] != NULL ) && ( qw != MyIP ) )
        {
          PChat[ qw ] ->ShowWindow( SW_SHOW );
          PChat[ qw ] ->SetDefID( IDC_PSEND );
          PChat[ qw ] ->Max = 1;
          Said[ qw ] = 0;
          UpdateList();
        }
        m_Wpis.Empty();
      }
    }
    else SendLCMsg( LC_NORMAL, LC_BROADCAST, LPCTSTR( m_Wpis ) );
    m_Wpis = '\0';
    UpdateData( FALSE );
  }
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::OnTimer(UINT nIDEvent)
{
  int nReceived=0;
  char host[16];
  int show=1;
  LC_DATA_HEAD LCData;

  // please read carefully the sources, determine timer events
  // and correct the next line
  if (nIDEvent==4)
  {
    if (SetupDialog->nCg==1)
    {
      strcpy(Nick[MyIP],LPCTSTR(SetupDialog->m_Nick));
      SetUser(MyIP,USER_PRESENT);
      UpdateList();
      SendLCMsg(LC_NEWNICK,LC_BROADCAST,"\0");
      SetupDialog->nCg=0;
    }

    if (TopicDialog->tCh==1)
    {
      TopicDialog->tCh=0;
      if (strcmp(TopicDialog->pTopic,TopicDialog->cTopic)!=0)
      {
        char kom[300];
        wsprintf(kom,"%s (%s)",TopicDialog->cTopic,SetupDialog->m_Nick);
        SendLCMsg(LC_NEWTOPIC,LC_BROADCAST,kom);
        GetLocalTime(&Czas);
        wsprintf(TopicDialog->Time,"%02d:%02d:%02d",Czas.wHour,Czas.wMinute,Czas.wSecond);
        SendLCMsg(LC_TOPIC_TIME,LC_BROADCAST,TopicDialog->Time);
      }
    }

    for(int n=0;n<256;n++) if ((LAGs[n]<5)&&(Status[n]==USER_PRESENT)||(Status[n]==USER_AWAY)) LAGs[n]++;
    CountLAG();
    if (Status[MyIP]==USER_PRESENT) SendLCMsg(LC_ALIVE,LC_BROADCAST,"\0");
    if (Status[MyIP]==USER_AWAY) SendLCMsg(LC_AWAY_ALIVE,LC_BROADCAST,"\0");
  }

  // please read carefully the sources, determine timer events
  // and correct the next line
  if (nIDEvent==3)
  {
    if (FirstRun==0)
    {
      if (Minimized==1)
      {
        WindowPlcmnt.length=sizeof(WindowPlcmnt);
        GetWindowPlacement(&WindowPlcmnt);
        WindowPlcmnt.showCmd=SW_SHOWMINIMIZED;
        WindowPlcmnt.length=sizeof(WindowPlcmnt);
        SetWindowPlacement(&WindowPlcmnt);
        WindowPlcmnt.length=sizeof(WindowPlcmnt);
        GetWindowPlacement(&WindowPlcmnt);
        WindowPlcmnt.showCmd=SW_HIDE;
        WindowPlcmnt.length=sizeof(WindowPlcmnt);
        SetWindowPlacement(&WindowPlcmnt);
        WndStatus=0;
        Minimized=0;
      }
      FirstRun=1;
      gethostname(host,30);
      unsigned char IP1,IP2,IP3,IP4;
      pHostEnt=gethostbyname(host);
      IP1=*(pHostEnt->h_addr);
      IP2=*(pHostEnt->h_addr+1);
      IP3=*(pHostEnt->h_addr+2);
      IP4=*(pHostEnt->h_addr+3);

      wsprintf(message,"(%s, IP=%u.%u.%u.%u)",host,IP1,IP2,IP3,IP4);
      CleanNicks();
      SendLCMsg(LC_JOIN,LC_BROADCAST,message);
      SendLCMsg(LC_SLC_OK,LC_BROADCAST,"\0");
          strcpy(Nick [ MyIP ], SetupDialog->m_Nick);
    }

    while (((nReceived=ReceivingSock.ReceiveFrom((void *)cRecData,(int)4150,cIP,cPort,0))>0)||(FirstTimer==1))
    {
      NetAlive=1;
      TopicDialog->TotalMessages++;
      FirstTimer=0;
      if (nReceived!=-1)
      {
        TopicDialog->Bytes+=nReceived;
        UpdateData(TRUE);
        memcpy(&LCData,cRecData,sizeof(LCData));

        if ((LCData.cHead[0]!='L')||(LCData.cHead[1]!='C')||
              (LCData.cHead[2]!='4')||(LCData.cHead[3]!='0'))
        {
          char bm[100];
          wsprintf(bm,"Bad message from %u: ",LCData.cSender);
          if (Dev==1) AddText(64,64,64,bm,0,0);
          if (Dev==1) AddText(30,30,30,LCData.Data,0,0);
          return;
        }

        strcpy(IPs[LCData.cSender],LPCSTR(cIP));

        if ((Dev==1)&&((LCData.cType==LC_NORMAL)||(LCData.cType==LC_AWAY)))
        {
          char mes[400];
          wsprintf(mes,"[%s]:",LPCSTR(cIP));
          AddText(30,30,30,mes,0,0);
          AddText(100,100,100,LCData.Data,0,0);
          wsprintf(mes,"\n");
          AddText(100,100,100,mes,0,0);
        }

        if ((Dev==1)&&(LCData.cType!=102)&&(LCData.cType!=111)&&(LCData.cType!=115))
        {
          char mesx[50];
          wsprintf(mesx,"%d->%d (%d) ",LCData.cSender,LCData.cDest,LCData.cType);
          AddText(0,0,0,mesx,0,0);
        }

        if (
              (LCData.cType!=LC_CANTPOP)&&
              (LCData.cType!=LC_POPOK)&&
              (LCData.cType!=LC_AWAY_ALIVE)&&
              (LCData.cType!=LC_NEWNICK)&&
              (LCData.cType!=LC_LEAVE)&&
              (LCData.cType!=LC_REQ_ALIVE)&&
              (LCData.cType!=LC_REQ_AWAY)&&
              (LCData.cType!=LC_REQ_STATUS_EX)&&
              (LCData.cType!=LC_END_AWAY)&&
              (LCData.cType!=LC_SLC_OK)&&
              (LCData.cType!=LC_ALIVE)&&
              (LCData.cType!=LC_LINUX_MSG)&&
              (LCData.cType!=LC_LINUX_POP)
              )
        {
          unsigned int qe;
          qe=0;
          while(1)
          {
            if ((LCData.Data[qe]=='L')&&
                  (LCData.Data[qe+1]=='C')&&
                  (LCData.Data[qe+2]=='4')&&
                  (LCData.Data[qe+3]=='0'))
            {
              LCData.Data[qe-1]=0;
                          break;
            }

            if (LCData.cCrypt == CRYPT_SLC)
            {
              LCData.Data[qe]--;
              LCData.Data[qe] = (char) (LCData.Data[qe] ^ ( LCData.xVal + 107 ));
            }
            LCData.Data[qe] = (unsigned char)(LCData.Data[qe] - LCData.cSender - LCData.cDest);
            LCData.Data[qe] = (unsigned char)(255 - LCData.Data[qe]);
            LCData.Data[qe] = (unsigned char)(LCData.Data[qe] - 20 + LCData.xVal);
            qe++;
            if (qe>4000)
            {
              char miu[60]="Decrypt overflow!\n";
              if (Dev==1) AddText(64,64,64,miu,0,0);
              return;
            }
          }
        }

        if (LCData.cType==LC_NORMAL || LCData.cType==LC_ME)
        {
          for(unsigned int s1=0;s1<strlen(LCData.Data);s1++)
          {
            CHO[tolower(LCData.Data[s1])]++;
            Chars[LCData.cSender]++;
            if (LCData.Data[s1]==' ' && LCData.Data[s1+1]!=' ') Words[LCData.cSender]++;
          }
          Words[LCData.cSender]+=2;
        }

        if ((LCData.cType!=LC_JOIN)&&(Status[LCData.cSender]==USER_TIMED)
              &&(LCData.cType!=LC_REQ_ALIVE))
        {
          char mesx[60];
          GetLocalTime(&Czas);

          if (Language==US) wsprintf(mesx,"%s has resurrected at %02d:%02d:%02d.\n",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond);
          else if (LCData.Female==0) wsprintf(mesx,"%s zmartwychwsta o %02d:%02d:%02d.\n",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond);
                   else wsprintf(mesx,"%s zmartwychwstaa o %02d:%02d:%02d.\n",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond);

          AddText(64,64,64,mesx,0,1);
          if ((PChat[LCData.cSender]!=NULL)&&(LCData.cSender!=MyIP))
          {
            PChat[LCData.cSender]->AddText(64,64,64,mesx,0,0,0);
          }
          SetUser(LCData.cSender,USER_PRESENT);
        }
        LAGs[LCData.cSender]=0;
        CountLAG();

        if ((PChat[LCData.cSender]==NULL)&&(LCData.cSender!=MyIP))
        {
          PChat[LCData.cSender]=new CPrivateDlg;
          PChat[LCData.cSender]->Create(IDD_PRIV_CHAT,NULL);
          PChat[LCData.cSender]->IP=(unsigned char)(LCData.cSender);
          PChat[LCData.cSender]->Own=this;
          PChat[LCData.cSender]->SetWindowText(LCData.cNick);
          PChat[LCData.cSender]->Max=0;
          PChat[LCData.cSender]->ShowWindow(SW_HIDE);
        }
        if (LCData.cSender!=MyIP) PChat[LCData.cSender]->SetWindowText(LCData.cNick);

        if (((LCData.cDest==MyIP)||(LCData.cDest==LC_BROADCAST)
               ||(LCData.cSender==MyIP))
              ||(Sn==1))
          switch (LCData.cType)
          {

          case LC_SLC_OK:
            if (LCData.cSender!=LC_BROADCAST) CryptType[LCData.cSender]=CRYPT_SLC;
            break;

          case LC_NEWNICK:
                        if (LCData.cSender!=MyIP)
                        {
                          char mes[100];
                          if (Language == US) wsprintf(mes,"%s takes %s's place.\n",LCData.cNick,Nick[LCData.cSender]);
                           else wsprintf(mes,"%s ustpuje miejsca, teraz %s.\n",Nick[LCData.cSender],LCData.cNick);
                          AddText(64,64,64,mes,0,1);
                          strcpy(Nick[LCData.cSender],LCData.cNick);
              UpdateList();
                        }
            break;

          case LC_MOTHER:
            if (LCData.cSender!=MyIP)
            {
              char mes[100];
              if (Language==US) wsprintf(mes,"%s has a mother-attack !\n",LCData.cNick);
              else wsprintf(mes,"%s ma rozmow kontrolowan !\n",LCData.cNick);
              AddText(64,64,64,mes,0,1);
            }
            break;

          case LC_REQ_STATUS_EX:
            {
              char statusex[200];
              char _host[30];
              char _user[60];
              unsigned long b=60;
              char _Aw;
              unsigned char IP1,IP2,IP3,IP4;

              gethostname(_host,30);
              GetUserName(_user,&b);
              pHostEnt=gethostbyname(_host);
              IP1=*(pHostEnt->h_addr);
              IP2=*(pHostEnt->h_addr+1);
              IP3=*(pHostEnt->h_addr+2);
              IP4=*(pHostEnt->h_addr+3);

              if (Status[MyIP]==USER_AWAY) _Aw=1; else _Aw=0;
              wsprintf(statusex,"%s\x07%s@%s\x07%u.%u.%u.%u\x07%s\x07%s\x07%d\x07%s\x07",Nick[MyIP],_user,_host,IP1,IP2,IP3,IP4,LC_Version,LC_OS,_Aw,Start);
              SendLCMsg(LC_STATUS_EX,LCData.cSender,statusex);
                          if (LCData.cSender != MyIP && SetupDialog->adv == 1)
                          {
                                  char kom[100];
                                  if (Language==US) wsprintf(kom,"%s checks your status.\n",LCData.cNick);
                                   else wsprintf(kom,"%s sprawdza twoje dane.\n",LCData.cNick);
                                  AddText(64,64,64,kom,0,0);
                          }
            }
            break;

          case LC_STATUS_EX:
            if (LCData.cDest==MyIP)
            {
              UsersDialog->AddUser(LCData.Data);
            }
            break;

          case LC_NORMAL:
            if ((strcmp(LCData.Data,OldLC.Data)!=0)||(LCData.cSender!=OldLC.cSender))
            {
              if (LCData.cDest==LC_BROADCAST)
              {
                if (SetupDialog->snicks==1)
                {
                  if (SetupDialog->msgtime==0)
                  {
                    wsprintf(message,"[%s]   %s",LCData.cNick,LCData.Data);
                  }
                  else
                  {
                    GetLocalTime(&Czas);
                    wsprintf(message,"[%s %02d:%02d:%02d]   %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
                  }
                }
                else
                {
                  if (SetupDialog->msgtime==0)
                  {
                    wsprintf(message,"%s",LCData.Data);
                  }
                  else
                  {
                    GetLocalTime(&Czas);
                    wsprintf(message,"%02d:%02d:%02d  %s",Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
                  }
                  //                                                                       wsprintf(message,"%s",LCData.Data);
                }
                AddText(LCData.nR,LCData.nG,LCData.nB,message,0,0);
                if ((SetupDialog->m_SoundCard==1)&&((LCData.cSender!=MyIP)||(LCData.cDest==LC_BROADCAST))) PlaySound("sounds\\public.wav",NULL,SND_FILENAME|SND_ASYNC);
                wsprintf(message,"[%s]   %s",LCData.cNick,LCData.Data);
                AddText(LCData.nR,LCData.nG,LCData.nB,message,0,2);
              }
              if ( (LCData.cDest==MyIP)||
                    ((LCData.cSender==MyIP)&&(LCData.cDest!=LC_BROADCAST)))
              {
                if (LCData.cDest==MyIP)
                {
                  if (SetupDialog->m_SoundCard==1) PlaySound("sounds\\private.wav",NULL,SND_FILENAME|SND_ASYNC);
                  if (SetupDialog->spnicks==1) wsprintf(message,"[%s]   %s",LCData.cNick,LCData.Data);
                  else wsprintf(message,"%s",LCData.Data);
                  PChat[LCData.cSender]->AddText(LCData.nR,LCData.nG,LCData.nB,message,0,0,1);
                  if ((PChat[LCData.cSender]->Max==0)&&(Said[LCData.cSender]==0))
                  {
                    Said[LCData.cSender]=1; UpdateList();
                  }
                }
                else
                  if ((LCData.cSender==MyIP)&&(LCData.cDest!=MyIP))
                  {
                    if (SetupDialog->spnicks==1) wsprintf(message,"[%s]   %s",LCData.cNick,LCData.Data);
                    else wsprintf(message,"%s",LCData.Data);
                    PChat[LCData.cDest]->AddText(LCData.nR,LCData.nG,LCData.nB,message,0,0,1);
                    if ((PChat[LCData.cDest]->Max==0)&&(Said[LCData.cDest]==0))
                    {
                      Said[LCData.cDest]=1; UpdateList();
                    }
                  }
              }
              if ((LCData.cSender!=MyIP)&&(LCData.cDest!=MyIP)&&(LCData.cDest!=LC_BROADCAST))
              {
                wsprintf(message,"#%s->%s  %s",LCData.cNick,Nick[LCData.cDest],LCData.Data,0,0);
                AddText(64,64,64,message,0,0);
              }
              SetUser(LCData.cSender,USER_PRESENT);
              TopicDialog->ChatMessages++;
            }
            break;

          case LC_ME:
            if ((strcmp(LCData.Data,OldLC.Data)!=0)||(LCData.cSender!=OldLC.cSender))
            {
              if (LCData.cDest==LC_BROADCAST)
              {
                wsprintf(message,"* %s %s",LCData.cNick,LCData.Data);
                AddText(LCData.nR,LCData.nG,LCData.nB,message,1);
              }
              if ( (LCData.cDest==MyIP)||
                    ((LCData.cSender==MyIP)&&(LCData.cDest!=LC_BROADCAST)))
              {

                if (LCData.cDest==MyIP)
                {
                  wsprintf(message,"* %s %s",LCData.cNick,LCData.Data);
                  PChat[LCData.cSender]->AddText(LCData.nR,LCData.nG,LCData.nB,message,1,0,1);
                  if ((PChat[LCData.cSender]->Max==0)&&(Said[LCData.cSender]==0))
                  {
                    Said[LCData.cSender]=1; UpdateList();
                  }
                }
                else
                  if ((LCData.cSender==MyIP)&&(LCData.cDest!=MyIP))
                  {
                    wsprintf(message,"* %s %s",LCData.cNick,LCData.Data);
                    PChat[LCData.cDest]->AddText(LCData.nR,LCData.nG,LCData.nB,message,1,0,1);
                    if ((PChat[LCData.cDest]->Max==0)&&(Said[LCData.cDest]==0))
                    {
                      Said[LCData.cDest]=1; UpdateList();
                    }
                  }
              }

              if ((LCData.cSender!=MyIP)&&(LCData.cDest!=MyIP)&&(LCData.cDest!=LC_BROADCAST))
              {
                wsprintf(message,"#[%s] --> (%d) * %s",LCData.cNick,LCData.cDest,LCData.Data,1,0);
                AddText(64,64,64,message,1,0);
              }
              SetUser(LCData.cSender,USER_PRESENT);
              TopicDialog->ChatMessages++;
            }
            break;

          case LC_JOIN:
            if (LCData.cSender!=MyIP) SendLCMsg(LC_SLC_OK,LCData.cSender,"\0");
            GetLocalTime(&Czas);
            if (Language==US) wsprintf(message,"%s joined at %02d:%02d:%02d from %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
            else if (LCData.Female==0) wsprintf(message,"%s doczy o %02d:%02d:%02d z %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
                         else wsprintf(message,"%s doczya o %02d:%02d:%02d z %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
            if (LCData.cSender==MyIP) SetupDialog->q=1;
            AddText(64,64,64,message);
            if (LCData.cSender==MyIP) SetupDialog->q=0;
            SetUser(LCData.cSender,USER_PRESENT);
            if (m_Away==FALSE) SendLCMsg(LC_ALIVE,LCData.cSender,"\0");
            else SendLCMsg(LC_AWAY_ALIVE,LCData.cSender,"\0");
            if (LCData.cSender!=MyIP)
            {
              SendLCMsg(LC_TOPIC,LCData.cSender,TopicDialog->cTopic);
              SendLCMsg(LC_TOPIC_TIME,LCData.cSender,TopicDialog->Time);
            }
            if ((PChat[LCData.cSender]!=NULL)&&(LCData.cSender!=MyIP))
            {
              PChat[LCData.cSender]->AddText(64,64,64,message,0,0,0);
            }
            if (SetupDialog->m_SoundCard==1) PlaySound("sounds\\join.wav",NULL,SND_FILENAME|SND_ASYNC);
                        strcpy(Nick[LCData.cSender],LCData.cNick);
            UpdateList();
            break;

          case LC_AWAY:
            if ((LCData.cDest==MyIP)||(LCData.cDest==LC_BROADCAST))
            {
              if (Language==US) wsprintf(message,"%s is away: %s",LCData.cNick,LCData.Data);
              else if (LCData.Female==0) wsprintf(message,"%s jest nieobecny: %s",LCData.cNick,LCData.Data);
                           else wsprintf(message,"%s jest nieobecna: %s",LCData.cNick,LCData.Data);
              AddText(64,64,64,message);
            }
            SetUser(LCData.cSender,USER_AWAY);
            break;

          case LC_LEAVE:
            GetLocalTime(&Czas);
            if (Language==US) wsprintf(message,"%s left at %02d:%02d:%02d\x0d\x0a",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
            else if (LCData.Female==0) wsprintf(message,"%s opuci LANChata o %02d:%02d:%02d\x0d\x0a",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
                         else wsprintf(message,"%s opucia LANChata o %02d:%02d:%02d\x0d\x0a",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
            LAGs[LCData.cSender]=0;
            AddText(64,64,64,message);
            if (LCData.cSender!=MyIP)
            {
              CString Maniek;
              Maniek=Nick[LCData.cSender];
              if (Language==US) Maniek+=" [not present]";
              else if (LCData.Female==0) Maniek+=" [nieobecny]";
                           else Maniek+=" [nieobecna]";
              PChat[LCData.cSender]->SetWindowText(Maniek);
              PChat[LCData.cSender]->AddText(64,64,64,message,0,0,0);
            }
            SetUser(LCData.cSender,USER_GONE);
            if (SetupDialog->m_SoundCard==1) PlaySound("sounds\\leave.wav",NULL,SND_FILENAME|SND_ASYNC);
            UpdateData(FALSE);
            break;

          case LC_START_AWAY:
            GetLocalTime(&Czas);
            if (Language==US) wsprintf(message,"%s went away at %02d:%02d:%02d: %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
            else if (LCData.Female==0) wsprintf(message,"%s wyszed o %02d:%02d:%02d: %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
                         else wsprintf(message,"%s wysza o %02d:%02d:%02d: %s",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond,LCData.Data);
            AddText(64,64,64,message);
            SetUser(LCData.cSender,USER_AWAY);
            break;

          case LC_ALIVE:
                        strcpy(Nick[LCData.cSender],LCData.cNick);
            SetUser(LCData.cSender,USER_PRESENT);
            break;

          case LC_AWAY_ALIVE:
                        strcpy(Nick[LCData.cSender],LCData.cNick);
            SetUser(LCData.cSender,USER_AWAY);
            break;

          case LC_REQ_ALIVE:
            if ((LCData.cDest==MyIP)||(LCData.cDest==LC_BROADCAST))
              if (m_Away==FALSE) SendLCMsg(LC_ALIVE,LCData.cSender,"\0");
              else SendLCMsg(LC_AWAY_ALIVE,LCData.cSender,"\0");
            break;

          case LC_REQ_AWAY:
            if ((LCData.cDest==MyIP)||(LCData.cDest==LC_BROADCAST))
              if (m_Away==TRUE) SendLCMsg(LC_AWAY,LCData.cSender,(LPCTSTR)m_Wpis);
                    if (LCData.cSender != MyIP && SetupDialog->adv == 1)
                        {
                          char kom[100];
                          if (Language==US) wsprintf(kom,"%s checks your away message.\n",LCData.cNick);
                           else wsprintf(kom,"%s sprawdza czemu Ci nie ma.\n",LCData.cNick);
                          AddText(64,64,64,kom,0,0);
                        }
            break;

          case LC_END_AWAY:
            GetLocalTime(&Czas);
            if (Language==US) wsprintf(message,"%s came back at %02d:%02d:%02d!\x0d\x0a",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond);
            else if (LCData.Female==0) wsprintf(message,"%s wrci o %02d:%02d:%02d!\x0d\x0a",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond);
                         else wsprintf(message,"%s wrcia o %02d:%02d:%02d!\x0d\x0a",LCData.cNick,Czas.wHour,Czas.wMinute,Czas.wSecond);
            AddText(64,64,64,message);
            SetUser(LCData.cSender,USER_PRESENT);
            break;

          case LC_NEWTOPIC:
            char kom[150];
            if (Language==US) wsprintf(kom,"%s changed topic to: ",LCData.cNick);
            else wsprintf(kom,"%s zmienia temat na: ",LCData.cNick);
            AddText(64,64,64,kom,0,1);
            AddText(LCData.nR,LCData.nG,LCData.nB,LCData.Data,0,1);
            {
              for(unsigned int t=0;t<strlen(LCData.Data);t++)
                if ((LCData.Data[t]==0x0a)||(LCData.Data[t]==0x0d)) LCData.Data[t]='\0';
            }
            strcpy(TopicDialog->cTopic,LCData.Data);
            wsprintf(kom,"LANChat: %s",TopicDialog->cTopic);
            SetWindowText(kom);
            break;

          case LC_CANTPOP:
            if (LCData.cDest==MyIP)
            {
              char text[70];
              if (Language==US) wsprintf(text,"%s has PopUp-s disabled.\n",Nick[LCData.cSender]);
              else wsprintf(text,"%s ma wyczone 'karteczki'.\n",Nick[LCData.cSender]);
              if (LCData.cSender!=MyIP) PChat[LCData.cSender]->AddText(64,64,64,text,0,0,1);
            }
            break;

          case LC_POPOK:
            if ((LCData.cSender!=MyIP)&&(LCData.cDest==MyIP))
            {
              if (Language==US)
                PChat[LCData.cSender]->AddText(64,64,64,"PopUp displayed.\n",0,0,1);
              else
                PChat[LCData.cSender]->AddText(64,64,64,"Karteczka przyjta.\n",0,0,1);
            }
            break;

          case LC_POPUP:
            char text[70];
            if (LCData.cDest==MyIP)
            {
              GetLocalTime(&Czas);
              switch (SetupDialog->PopMode)
              {
              case 0: SendLCMsg(LC_CANTPOP,LCData.cSender,""); break;
              case 1: if (m_Away==FALSE)
                {
                  if (Language==US) wsprintf(text,"LANChat PopUp from %s [%02d:%02d]",LCData.cNick,Czas.wHour,Czas.wMinute);
                  else wsprintf(text,"Karteczka LANChatowa od %s [%02d:%02d]",LCData.cNick,Czas.wHour,Czas.wMinute);
                  if (SetupDialog->m_SoundCard==1) PlaySound("sounds\\popup.wav",NULL,SND_FILENAME|SND_ASYNC);
                  MessageBox(LCData.Data,text,MB_OK);
                  SendLCMsg(LC_POPOK,LCData.cSender,"");
                }
                else SendLCMsg(LC_CANTPOP,LCData.cSender,"");
                break;
              case 2: if (m_Mute==FALSE)
                {
                  if (Language==US) wsprintf(text,"LANChat PopUp from %s [%02d:%02d]",LCData.cNick,Czas.wHour,Czas.wMinute);
                  else  wsprintf(text,"Karteczka LANChatowa od %s [%02d:%02d]",LCData.cNick,Czas.wHour,Czas.wMinute);
                  if (SetupDialog->m_SoundCard==1) PlaySound("sounds\\popup.wav",NULL,SND_FILENAME|SND_ASYNC);
                  MessageBox(LCData.Data,text,MB_OK);
                  SendLCMsg(LC_POPOK,LCData.cSender,"");
                }
                else SendLCMsg(LC_CANTPOP,LCData.cSender,"");
                break;
              case 3:
                if (Language==US) wsprintf(text,"LANChat PopUp from %s [%02d:%02d]",LCData.cNick,Czas.wHour,Czas.wMinute);
                else wsprintf(text,"Karteczka LANChatowa od %s [%02d:%02d]",LCData.cNick,Czas.wHour,Czas.wMinute);
                if (SetupDialog->m_SoundCard==1) PlaySound("sounds\\popup.wav",NULL,SND_FILENAME|SND_ASYNC);
                MessageBox(LCData.Data,text,MB_OK);
                SendLCMsg(LC_POPOK,LCData.cSender,"");
                break;
              }
            }
            break;

          case LC_TOPIC:
            if ((LCData.cDest==MyIP)&&(LCData.cSender!=MyIP))
            {
              {
                for(unsigned int t=0;t<strlen(LCData.Data);t++)
                  if ((LCData.Data[t]==0x0a)||(LCData.Data[t]==0x0d)) LCData.Data[t]='\0';
              }
              strcpy(TopicDialog->cTopic,LCData.Data);
              wsprintf(kom,"LANChat: %s",TopicDialog->cTopic);
              if ((TopicDialog->cTopic[0]!='<')&&(TopicDialog->cTopic[1]!='>')) SetWindowText(kom);
              for(unsigned int t=0;t<strlen(kom);t++)
                if ((kom[t]==0x0a)||(kom[t]==0x0d)) kom[t]='\0';
            }
            break;

          case LC_TOPIC_TIME:
            {
              for(unsigned int t=0;t<strlen(LCData.Data);t++)
                if ((LCData.Data[t]==0x0a)||(LCData.Data[t]==0x0d)) LCData.Data[t]='\0';
            }
            strcpy(TopicDialog->Time,LCData.Data);
          }
        UpdateData(FALSE);
      }

      if ((LCData.cSender==MyIP)||(LCData.cDest==LC_BROADCAST)||
            (LCData.cDest==MyIP))
      {
        if ((LCData.cType==LC_NORMAL)||(LCData.cType==LC_ME))
          memcpy(&OldLC,&LCData,sizeof(LCData));
      }
    }
  }
  CDialog::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::StdIcon()
{
  NotifyIcon.cbSize = sizeof( NOTIFYICONDATA );
  NotifyIcon.hWnd = this->m_hWnd;
  NotifyIcon.uID = IDR_MAINFRAME;
  NotifyIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
  NotifyIcon.uCallbackMessage = WM_USER + 19;
  strcpy( NotifyIcon.szTip, "LANChat 4.0" );
  NotifyIcon.hIcon = LANChatApp->LoadIcon( IDR_MAINFRAME );
  Shell_NotifyIcon( NIM_MODIFY, &NotifyIcon );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::WarnIcon()
{
  NotifyIcon.cbSize = sizeof( NOTIFYICONDATA );
  NotifyIcon.hWnd = this->m_hWnd;
  NotifyIcon.uID = IDR_MAINFRAME;
  NotifyIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
  NotifyIcon.uCallbackMessage = WM_USER + 19;
  strcpy( NotifyIcon.szTip, "LANChat 4.0" );
  NotifyIcon.hIcon = LANChatApp->LoadIcon( IDI_WARN );
  Shell_NotifyIcon( NIM_MODIFY, &NotifyIcon );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::SetNotifyIcon()
{
  NotifyIcon.cbSize = sizeof( NOTIFYICONDATA );
  NotifyIcon.hWnd = this->m_hWnd;
  NotifyIcon.uID = IDR_MAINFRAME;
  NotifyIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
  NotifyIcon.uCallbackMessage = WM_USER + 19;
  strcpy( NotifyIcon.szTip, "LANChat 4.0" );
  NotifyIcon.hIcon = LANChatApp->LoadIcon( IDR_MAINFRAME );
  Shell_NotifyIcon( NIM_ADD, &NotifyIcon );
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::Minimize( void )
{
  pRect.left = SetupDialog->left;
  pRect.top = SetupDialog->top;
  pRect.right = SetupDialog->left + 250 + 247;
  pRect.bottom = SetupDialog->top + 175 + 175;
  WindowPlcmnt.length = sizeof( WindowPlcmnt );
  GetWindowPlacement( &WindowPlcmnt );
  WindowPlcmnt.showCmd = SW_MINIMIZE;
  WindowPlcmnt.length = sizeof( WindowPlcmnt );
  WindowPlcmnt.rcNormalPosition = pRect;
  SetWindowPlacement( &WindowPlcmnt );
  WndStatus = 0;
}

/////////////////////////////////////////////////////////////////////////////

void CLANChatDlg::UstawWielkosc( void )
{
  pRect.left = SetupDialog->left;
  pRect.top = SetupDialog->top;
  pRect.right = SetupDialog->left + 250 + 247;
  pRect.bottom = SetupDialog->top + 175 + 175;
  WindowPlcmnt.length = sizeof( WindowPlcmnt );
  GetWindowPlacement( &WindowPlcmnt );
  WindowPlcmnt.showCmd = SW_SHOW;
  WindowPlcmnt.length = sizeof( WindowPlcmnt );
  WindowPlcmnt.rcNormalPosition = pRect;
  SetWindowPlacement( &WindowPlcmnt );
}

/////////////////////////////////////////////////////////////////////////////

int CLANChatDlg::OnUser( WPARAM wParam, LPARAM lParam )
{
  if ( ( WndStatus == 0 ) && ( lParam == 513 ) )
  {
    WindowPlcmnt.length = sizeof( WindowPlcmnt );
    GetWindowPlacement( &WindowPlcmnt );
    WindowPlcmnt.showCmd = SW_SHOWNORMAL;
    WindowPlcmnt.length = sizeof( WindowPlcmnt );
    SetWindowPlacement( &WindowPlcmnt );
    WindowPlcmnt.length = sizeof( WindowPlcmnt );
    GetWindowPlacement( &WindowPlcmnt );
    WindowPlcmnt.showCmd = SW_SHOW; //MINIMIZE;
    WindowPlcmnt.length = sizeof( WindowPlcmnt );
    SetWindowPlacement( &WindowPlcmnt );
    WindowPlcmnt.length = sizeof( WindowPlcmnt );
    GetWindowPlacement( &WindowPlcmnt );
    WindowPlcmnt.showCmd = SW_RESTORE;
    WindowPlcmnt.length = sizeof( WindowPlcmnt );
    SetWindowPlacement( &WindowPlcmnt );

    GotoDlgCtrl( GetDlgItem( IDC_WPISYWANIE ) );
    ::SetFocus( m_hWnd );
    WndStatus = 1;
    StdIcon();
  }
  if ( ( WndStatus == 0 ) && ( lParam == 516 ) )
  {
    POINT punkt;
    GetCursorPos(&punkt);
    CMenu* PopMenu=Menu->GetSubMenu(0);
    PopMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON,punkt.x,punkt.y,this);
  }
  return TRUE;
  wParam;
}
