/*
    LANChat 4.0 for Windows 95OSR2/98/NT4
   --------------------------------------------------------
    (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)

    LANChat and related utilities are free software; you can
    redistribute it and/or modify it under the terms of the GNU Library
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

*/

// LANCHAT 4.0 SPECIFICATION
// All Rights Reserved
// (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)
//

// send message to all users
#define LC_BROADCAST 255

// LANChat messages

/*
 *  NMR - No Message Return
 *  AB - Always Broadcast
 *  OD - Only Direct sending (no broadcast allowed)
 *  AO - Answer On (LC_???) - send this as an answer for a message
 *  AW - Answer With (LC_???) - send LC_??? as an answer for this message
 */

// #define LC_NAME number // DATA, Attributes
#define LC_NEWTOPIC 50 // TopicText, NMR+AB
#define LC_TOPIC 53 // TopicText, NMR+OD+AO(LC_JOIN)
#define LC_TOPIC_TIME 54 // TopicTime, NMR+OD+AO(LC_JOIN)
#define LC_CANTPOP 55 // -, NMR+OD+AO(LC_POPUP)
#define LC_POPOK 57 // -, NMR+OD+AO(LC_POPUP)
#define LC_POPUP 62 // PopUpText, AW(LC_POPOK or LC_CANTPOP)+OD
#define LC_MOTHER 78 // -, NMR+AB
#define LC_NORMAL 100 // ChatText, -
#define LC_AWAY 101 // AwayMessage+AwayTime, NMR+OD+AO(LC_REQ_AWAY)
#define LC_ALIVE 102 // -, NMR+AO(LC_REQ_ALIVE or LC_JOIN)
#define LC_AWAY_ALIVE 115 // -, NMR+AO(LC_REQ_ALIVE or LC_JOIN)
#define LC_NEWNICK 116 // -, NMR+AB
#define LC_ME 104 // MeText, -
#define LC_JOIN 107 // (see sources), AB+AW(LC_ALIVE or LC_REQ_ALIVE, LC_TOPIC, LC_TOPIC_TIME)
#define LC_LEAVE 108 // -, NMR+AB
#define LC_REQ_AWAY 110 // -, OD+AW(LC_AWAY)
#define LC_REQ_ALIVE 111 // -, AW(LC_ALIVE or LC_REQ_ALIVE)
#define LC_START_AWAY 113 // AwayMessage, NMR+AB
#define LC_END_AWAY 114 // -, NMR+AB
#define LC_LINUX_MSG 1 // Reserved
#define LC_LINUX_POP 2 // Reserved
#define LC_REQ_STATUS_EX 90 // -, AB+AW(LC_STATUS_EX)
#define LC_STATUS_EX 91 // (see sources), NMR+OD+AO(LC_REQ_STATUS_EX)

// ports
#define INPORT 16128
#define OUTPORT 44145 // strongly recommended

// struktura pakietow sieciowych
typedef struct
{
  char cHead[4];                // "LC40"
  unsigned char cType;          // LC_???
  unsigned int cSender;         // last IP number
  unsigned int cDest;           // last IP number or LC_BROADCAST
  char cNick[20];               // sender's nick
                                // sender's colour:
  unsigned char nR;             // Red <0 - 255>
  unsigned char nG;             // Green <0 - 255>
  unsigned char nB;             // Blue <0 - 255>
  unsigned char xVal;           // Crypt value (see sources)
  unsigned char cCrypt;         // Reserved, must be 0
  char Female;			// 1 or 0
  unsigned long Reserved1;      // Reserved, must be 0
  unsigned long Reserved2;      // Reserved, must be 0
  unsigned long Reserved3;      // Reserved, must be 0
  char Data[4096];
} LC_DATA_HEAD;
