/*
    LANChat 4.0 for Windows 95OSR2/98/NT4
   --------------------------------------------------------
    (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)

    LANChat and related utilities are free software; you can
    redistribute it and/or modify it under the terms of the GNU Library
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

*/

#include "stdafx.h"
#include "LANChat.h"
#include "PrivateDlg.h"
#include "PopUpDlg.h"
#include "SetupDlg.h"

/////////////////////////////////////////////////////////////////////////////

CPrivateDlg::CPrivateDlg( CWnd* pParent)
    : CDialog( CPrivateDlg::IDD, pParent )
{
  Max = 0;
  //{{AFX_DATA_INIT(CPrivateDlg)
  m_PWpis = _T( "" );
  //}}AFX_DATA_INIT
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::OnCancel( void )
{
  ShowWindow( SW_HIDE );
  Own->m_Users.RedrawItems(0,255);
  Max = 0;
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::DoDataExchange( CDataExchange* pDX )
{
  CDialog::DoDataExchange( pDX );
  //{{AFX_DATA_MAP(CPrivateDlg)
  DDX_Text( pDX, IDC_PINPUT, m_PWpis );
  DDV_MaxChars( pDX, m_PWpis, 200 );
  //}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP( CPrivateDlg, CDialog )
//{{AFX_MSG_MAP(CPrivateDlg)
ON_BN_CLICKED( IDC_PSEND, OnPsend )
ON_BN_CLICKED( IDC_BUTTON1, OnPop )
ON_WM_SHOWWINDOW()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::OnPsend()
{
  UpdateData( TRUE );
  if ( ( m_PWpis.GetLength() == 2 ) && ( m_PWpis[ 1 ] == 'c' )
        && ( m_PWpis[ 0 ] == '/' ) )
  {
    SetDlgItemText( IDC_CHATBOX, "" );
  }
  if ( ( m_PWpis.GetLength() > 4 ) && ( m_PWpis[ 1 ] == 'm' ) &&   // /me
        ( m_PWpis[ 2 ] == 'e' ) && ( m_PWpis[ 3 ] == ' ' ) && ( m_PWpis[ 0 ] == '/' ) )
  {
    m_PWpis.SetAt( 0, ' ' ); m_PWpis.SetAt( 1, ' ' ); m_PWpis.SetAt( 2, ' ' );
    m_PWpis.TrimLeft();
    UpdateData( FALSE );
    Own->SendLCMsg( LC_ME, IP, LPCTSTR( m_PWpis ) );
    m_PWpis.Empty();
  }
  if ( ( m_PWpis.GetLength() == 4 ) && ( m_PWpis[ 1 ] == 'm' ) &&
        ( m_PWpis[ 2 ] == 'i' ) && ( m_PWpis[ 3 ] == 'n' ) )
  {
    ShowWindow( SW_HIDE );
    Max = 0;
    m_PWpis.Empty();
  }
  if ( ( m_PWpis.GetLength() > 0 ) && ( m_PWpis[ 0 ] != '/' ) ) Own->SendLCMsg( LC_NORMAL, IP, LPCTSTR( m_PWpis ) );
  m_PWpis.Empty();
  UpdateData( FALSE );
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::Bolden( void )
{
  TextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  TextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) TextLength, ( LPARAM ) TextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_GETCHARFORMAT, 0, ( LPARAM ) & CharFmt );
  CharFmt.cbSize = sizeof( CharFmt );
  CharFmt.dwEffects = CFE_BOLD;
  CharFmt.dwMask = CFM_BOLD;
  SendDlgItemMessage( IDC_CHATBOX, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & CharFmt );
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::Unbolden( void )
{
  TextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  TextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) TextLength, ( LPARAM ) TextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_GETCHARFORMAT, 0, ( LPARAM ) & CharFmt );
  CharFmt.cbSize = sizeof( CharFmt );
  CharFmt.dwEffects = 0;
  CharFmt.dwMask = CFM_BOLD;
  SendDlgItemMessage( IDC_CHATBOX, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & CharFmt );
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::Kolor( int r, int g, int b )
{
  TextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  TextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) TextLength, ( LPARAM ) TextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_GETCHARFORMAT, 0, ( LPARAM ) & CharFmt );
  CharFmt.cbSize = sizeof( CharFmt );
  CharFmt.crTextColor = RGB( r, g, b );
  CharFmt.dwEffects = 0;
  CharFmt.dwMask = CFM_COLOR;
  SendDlgItemMessage( IDC_CHATBOX, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & CharFmt );
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::AddText( int r, int g, int b, char *txt, char bolden = 0, char Logable = 1, char beep = 1 )
{
  if (fset==0)
  {
    CFont *cf=new CFont;
    cf->CreateFontIndirect(&(Own->SetupDialog->Font));
    SendDlgItemMessage(IDC_CHATBOX,WM_SETFONT,(WPARAM)HFONT(*cf),0);
    delete cf;
    fset=1;
  }

  if ( bolden == 1 ) Bolden();
  Kolor( r, g, b );
  TextLength = SendDlgItemMessage( IDC_CHATBOX, WM_GETTEXTLENGTH, 0, 0 );
  TextLength = SendDlgItemMessage( IDC_CHATBOX, EM_SETSEL, ( WPARAM ) TextLength, ( LPARAM ) TextLength );
  SendDlgItemMessage( IDC_CHATBOX, EM_REPLACESEL, ( WPARAM ) FALSE, ( LPARAM ) txt );
  SendDlgItemMessage( IDC_CHATBOX, EM_SCROLLCARET, 0, 0 );
  if ( bolden == 1 ) Unbolden();

  if ( ( Max == 0 ) && ( Own->m_Mute == FALSE ) && ( beep == 1 ) ) MessageBeep( 0xFFFFFFFF );
  if ( ( Own->WndStatus == 0 ) && ( Max == 0 ) ) Own->WarnIcon();

  if ( ( Own->AutoShow == 1 ) && ( Own->m_Mute == FALSE ) && ( beep == 1 ) )
  {
    ShowWindow( SW_NORMAL );
    Max = 1;
    Own->StdIcon();
  }
  Logable;
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::OnPop()
{
  UpdateData( TRUE );

  if ( m_PWpis.GetLength() == 0 )
  {
    Own->PopUpDialog->m_PopText = "";
    if ( Own->PopUpDialog->DoModal() == IDOK ) m_PWpis = Own->PopUpDialog->m_PopText;
  }
  if ( ( m_PWpis.GetLength() > 0 ) && ( m_PWpis[ 0 ] != '/' ) ) Own->SendLCMsg( LC_POPUP, IP, LPCTSTR( m_PWpis ) );
  m_PWpis.Empty();
  UpdateData( FALSE );
}

/////////////////////////////////////////////////////////////////////////////

BOOL CPrivateDlg::OnInitDialog()
{
  fset=0;
  CDialog::OnInitDialog();

  PopBut.LoadBitmaps( IDB_POP, IDB__POP, 0, 0 );
  VERIFY( PopBut.SubclassDlgItem( IDC_BUTTON1, this ) );
  PopBut.SizeToContent();
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////

void CPrivateDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
  CDialog ::OnShowWindow(bShow, nStatus);
  Own->m_Users.RedrawItems(0,255);
}

/////////////////////////////////////////////////////////////////////////////

BOOL CPrivateDlg::PreTranslateMessage(MSG* pMsg)
{
  if ( ( pMsg->message == WM_SYSKEYDOWN ) && ( pMsg->wParam == 112 ) )
  {
    UpdateData( TRUE );
    m_PWpis += Own->SetupDialog->Short->m_Sh1;
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_PINPUT, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_PINPUT, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
    if (m_PWpis.GetAt(m_PWpis.GetLength()-1)=='@')
    {
      m_PWpis.SetAt(m_PWpis.GetLength()-1,' ');
      UpdateData( FALSE );
      OnPsend();
    }
  }
  if ( ( pMsg->message == WM_SYSKEYDOWN ) && ( pMsg->wParam == 113 ) )
  {
    UpdateData( TRUE );
    m_PWpis += Own->SetupDialog->Short->m_Sh2;
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_PINPUT, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_PINPUT, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
    if (m_PWpis.GetAt(m_PWpis.GetLength()-1)=='@')
    {
      m_PWpis.SetAt(m_PWpis.GetLength()-1,' ');
      UpdateData( FALSE );
      OnPsend();
    }
  }
  if ( ( pMsg->message == WM_SYSKEYDOWN ) && ( pMsg->wParam == 114 ) )
  {
    UpdateData( TRUE );
    m_PWpis += Own->SetupDialog->Short->m_Sh3;
    UpdateData( FALSE );
    INT tlo;
    tlo = SendDlgItemMessage( IDC_PINPUT, WM_GETTEXTLENGTH, 0, 0 );
    tlo = SendDlgItemMessage( IDC_PINPUT, EM_SETSEL, ( WPARAM ) tlo, ( LPARAM ) tlo );
    if (m_PWpis.GetAt(m_PWpis.GetLength()-1)=='@')
    {
      m_PWpis.SetAt(m_PWpis.GetLength()-1,' ');
      UpdateData( FALSE );
      OnPsend();
    }
  }
  return CDialog ::PreTranslateMessage(pMsg);
}
