/*
    LANChat 4.0 for Windows 95OSR2/98/NT4
   --------------------------------------------------------
    (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)

    LANChat and related utilities are free software; you can
    redistribute it and/or modify it under the terms of the GNU Library
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

*/

#include "stdafx.h"
#include "LANChat.h"
#include "LANChatDlg.h"
#include "SetupDlg.h"
#include "ShortDlg.h"

/////////////////////////////////////////////////////////////////////////////

CSetupDlg::CSetupDlg( CWnd* pParent )
    : CDialog( CSetupDlg::IDD, pParent )
{
  //{{AFX_DATA_INIT(CSetupDlg)
  m_Log = FALSE;
  m_LogDir = _T( "" );
  m_AutoShow = FALSE;
  m_NewNick = _T( "" );
  m_UseCrd = FALSE;
  m_MsgTime = FALSE;
  m_snicks = FALSE;
  m_pnicks = FALSE;
	m_Female = FALSE;
	m_adv = FALSE;
	//}}AFX_DATA_INIT
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::DoDataExchange( CDataExchange* pDX )
{
  CDialog::DoDataExchange( pDX );
  //{{AFX_DATA_MAP(CSetupDlg)
  DDX_Control( pDX, IDC_SLIDER3, m_ColB );
  DDX_Control( pDX, IDC_SLIDER2, m_ColG );
  DDX_Control( pDX, IDC_SLIDER1, m_ColR );
  DDX_Check( pDX, IDC_LOG, m_Log );
  DDX_Text( pDX, IDC_EDIT2, m_LogDir );
  DDV_MaxChars( pDX, m_LogDir, 150 );
  DDX_Check( pDX, IDC_AUTOSHOW, m_AutoShow );
  DDX_Text( pDX, IDC_EDIT1, m_NewNick );
  DDV_MaxChars( pDX, m_NewNick, 19 );
  DDX_Check( pDX, IDC_PLAY, m_UseCrd );
  DDX_Check( pDX, IDC_MSGTIME, m_MsgTime );
  DDX_Check( pDX, IDC_SNICKS, m_snicks );
  DDX_Check( pDX, IDC_PNICKS, m_pnicks );
	DDX_Check(pDX, IDC_SEX, m_Female);
	DDX_Check(pDX, IDC_ADV, m_adv);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP( CSetupDlg, CDialog )
//{{AFX_MSG_MAP(CSetupDlg)
ON_BN_CLICKED( IDOK, OnSetupOK )
ON_WM_SHOWWINDOW()
ON_WM_HSCROLL()
ON_BN_CLICKED( IDC_RADIO0, OnRadio0 )
ON_BN_CLICKED( IDC_RADIO1, OnRadio1 )
ON_BN_CLICKED( IDC_RADIO2, OnRadio2 )
ON_BN_CLICKED( IDC_RADIO3, OnRadio3 )
ON_BN_CLICKED( IDC_ENGLISH, OnEnglish )
ON_BN_CLICKED( IDC_POLISH, OnPolish )
ON_BN_CLICKED( IDC_PAL, OnPal )
ON_BN_CLICKED( IDC_SHBUT, OnShbut )
ON_BN_CLICKED(IDC_FONT, OnFont)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnSetupOK()
{
  UpdateData( TRUE );
  Logging = m_Log;
  Female = m_Female;
  adv = m_adv;
  strcpy( LogDir, LPCTSTR( m_LogDir ) );
  m_R = m_ColR.GetPos();
  m_G = m_ColG.GetPos();
  m_B = m_ColB.GetPos();
  m_SoundCard = m_UseCrd;
  spnicks = m_pnicks;
  snicks = m_snicks;
  PopMode = nPop;
  if ( Language != nlang )
  {
    if ( nlang == PL ) MessageBox( "Powiniene ponownie uruchomi LANChata, by zmiany poprawnie zadziaay.\n", "LANChat 4.0", MB_OK );
    else MessageBox( "You should restart the application to activate changes.\n", "LANChat 4.0", MB_OK );
  }
  Language = nlang;
  Owner->Language = Language;
  Owner->AutoShow = m_AutoShow;
  msgtime = m_MsgTime;
  memcpy(&Font,&tFont,sizeof(LOGFONT));

  char Acceptable = 1;

  for ( int nM = 0; nM < 255; nM++ )
	  if ( strcmp( LPCTSTR( m_NewNick ), Owner->Nick[ nM ] ) == 0 ) Acceptable = 0;
  
  nCg = 0;
  if ( Acceptable == 1 )
  {
    m_Nick = m_NewNick;
	nCg = 1;
  }

  Owner->WriteConfig();
  ShowWindow( SW_HIDE );
  Owner->SendMessage( WM_TIMER, 2, 2 );
}

/////////////////////////////////////////////////////////////////////////////

BOOL CSetupDlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  Short = new CShortDlg;
  Short->Owner = this;

  m_ColR.SetRangeMax( 255, FALSE );
  m_ColR.SetRangeMin( 0, FALSE );
  m_ColG.SetRangeMax( 255, FALSE );
  m_ColG.SetRangeMin( 0, FALSE );
  m_ColB.SetRangeMax( 255, FALSE );
  m_ColB.SetRangeMin( 0, FALSE );
  m_ColR.SetTicFreq( 1 );
  m_ColG.SetTicFreq( 1 );
  m_ColB.SetTicFreq( 1 );
  nlang = Language;
  UpdateData( FALSE );
  if ( Language == PL )
  {
    SetDlgItemText( IDC_NICKNAME, "Ksywa:" );
    SetDlgItemText( IDC_COLOR, "Kolor:" );
    SetDlgItemText( IDC_LOGGING, "Rejestrowanie" );
    SetDlgItemText( IDC_LOG, "Wczone" );
    SetDlgItemText( IDC_DIRECTORY, "Katalog:" );
    SetDlgItemText( IDC_SHOWPOPUPS, "Karteczki" );
    SetDlgItemText( IDC_ALWAYS, "Zawsze" );
    SetDlgItemText( IDC_IFSOUNDON, "Dwik" );
    SetDlgItemText( IDC_IFPRESENT, "Obecno" );
    SetDlgItemText( IDC_NEVER, "Nigdy" );
    SetDlgItemText( IDC_LANGUAGE, "Jzyk:" );
    SetDlgItemText( IDCANCEL, "Anuluj" );
    SetDlgItemText( IDC_AUTOSHOW, "Pokazuj okna prywatne gdy nadchodz wiadomoci" );
    SetDlgItemText( IDC_PLAY, "Odtwarzaj sygna 'karteczki' przez kart dwikow" );
    SetDlgItemText( IDC_MSGTIME, "Pokazuj czas w oknie rozmw" );
    SetDlgItemText( IDC_SNICKS, "Oknie gwnym" );
    SetDlgItemText( IDC_PNICKS, "Oknach prywatnych" );
    SetDlgItemText( IDC_STATICNICK, "Ksywy w" );
    SetDlgItemText( IDC_AUTOMIN, "Jeli chcesz, eby LANChat automatycznie adowa si na pasek zada wpisz parametr /q w jego skrcie w grupie Autostart." );
    SetDlgItemText( IDC_SHBUT, "Skrty" );
    SetDlgItemText( IDC_FONT, "Czcionka" );
	SetDlgItemText( IDC_POS, "Zapamituj pozycj na ekranie");
	SetDlgItemText( IDC_SEX, "Kobieta");
	SetDlgItemText( IDC_ADV, "Pokazuj dania innych");
    SetWindowText( "LANChat - opcje" );
	CheckDlgButton( IDC_POS, 1 );
  }
  return TRUE;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnShowWindow( BOOL bShow, UINT nStatus )
{
  CDialog::OnShowWindow( bShow, nStatus );

  m_adv = adv;
  memcpy(&tFont,&Font,sizeof(LOGFONT));
  m_NewNick = m_Nick;
  m_Log = Logging;
  m_LogDir = LogDir;
  nPop = PopMode;
  oNick = m_Nick;
  m_UseCrd = m_SoundCard;
  m_ColR.SetPos( m_R );
  m_ColG.SetPos( m_G );
  m_ColB.SetPos( m_B );
  m_AutoShow = Owner->AutoShow;
  m_MsgTime = msgtime;
  m_snicks = snicks;
  m_pnicks = spnicks;
  m_Female = Female;
  nlang = Language;
  switch ( PopMode )
  {
   case 0: CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO0 ); break;
   case 1: CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO1 ); break;
   case 2: CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO2 ); break;
   case 3: CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO3 ); break;
  }
  if ( Language == US ) CheckRadioButton( IDC_ENGLISH, IDC_POLISH, IDC_ENGLISH );
  else CheckRadioButton( IDC_ENGLISH, IDC_POLISH, IDC_POLISH );
  UpdateData( FALSE );
  AddText();
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::Bolden( void )
{
  tl = SendDlgItemMessage( IDC_TEST, WM_GETTEXTLENGTH, 0, 0 );
  tl = SendDlgItemMessage( IDC_TEST, EM_SETSEL, ( WPARAM ) tl, ( LPARAM ) tl );
  SendDlgItemMessage( IDC_TEST, EM_GETCHARFORMAT, 0, ( LPARAM ) & chf );
  chf.cbSize = sizeof( chf );
  chf.dwEffects = CFE_BOLD;
  chf.dwMask = CFM_BOLD;
  SendDlgItemMessage( IDC_TEST, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & chf );
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::Unbolden( void )
{
  tl = SendDlgItemMessage( IDC_TEST, WM_GETTEXTLENGTH, 0, 0 );
  tl = SendDlgItemMessage( IDC_TEST, EM_SETSEL, ( WPARAM ) tl, ( LPARAM ) tl );
  SendDlgItemMessage( IDC_TEST, EM_GETCHARFORMAT, 0, ( LPARAM ) & chf );
  chf.cbSize = sizeof( chf );
  chf.dwEffects = 0;
  chf.dwMask = CFM_BOLD;
  SendDlgItemMessage( IDC_TEST, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & chf );
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::Kolor( int r, int g, int b )
{
  tl = SendDlgItemMessage( IDC_TEST, WM_GETTEXTLENGTH, 0, 0 );
  tl = SendDlgItemMessage( IDC_TEST, EM_SETSEL, ( WPARAM ) tl, ( LPARAM ) tl );
  SendDlgItemMessage( IDC_TEST, EM_GETCHARFORMAT, 0, ( LPARAM ) & chf );
  chf.cbSize = sizeof( chf );
  chf.crTextColor = RGB( r, g, b );
  chf.dwEffects = 0;
  chf.dwMask = CFM_COLOR;
  SendDlgItemMessage( IDC_TEST, EM_SETCHARFORMAT, ( WPARAM ) SCF_SELECTION, ( LPARAM ) & chf );
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::AddText( void )
{
  UpdateData( TRUE );
  Kolor( m_ColR.GetPos(), m_ColG.GetPos(), m_ColB.GetPos() );
  Unbolden();
  SetDlgItemText( IDC_TEST, "" );
  char txt[] = "LANChat color test\n";
  tl = SendDlgItemMessage( IDC_TEST, WM_GETTEXTLENGTH, 0, 0 );
  tl = SendDlgItemMessage( IDC_TEST, EM_SETSEL, ( WPARAM ) tl, ( LPARAM ) tl );
  SendDlgItemMessage( IDC_TEST, EM_REPLACESEL, ( WPARAM ) FALSE, ( LPARAM ) txt );
  SendDlgItemMessage( IDC_TEST, EM_SCROLLCARET, 0, 0 );
  Bolden();
  strcpy( txt, "LANChat color test" );
  tl = SendDlgItemMessage( IDC_TEST, WM_GETTEXTLENGTH, 0, 0 );
  tl = SendDlgItemMessage( IDC_TEST, EM_SETSEL, ( WPARAM ) tl, ( LPARAM ) tl );
  SendDlgItemMessage( IDC_TEST, EM_REPLACESEL, ( WPARAM ) FALSE, ( LPARAM ) txt );
  SendDlgItemMessage( IDC_TEST, EM_SCROLLCARET, 0, 0 );
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
  AddText();
  CDialog::OnHScroll( nSBCode, nPos, pScrollBar );
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnRadio0()
{
  CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO0 );
  nPop = 0;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnRadio1()
{
  CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO1 );
  nPop = 1;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnRadio2()
{
  CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO2 );
  nPop = 2;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnRadio3()
{
  CheckRadioButton( IDC_RADIO0, IDC_RADIO3, IDC_RADIO3 );
  nPop = 3;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnEnglish()
{
  CheckRadioButton( IDC_ENGLISH, IDC_POLISH, IDC_ENGLISH );
  nlang = US;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnPolish()
{
  CheckRadioButton( IDC_ENGLISH, IDC_POLISH, IDC_POLISH );
  nlang = PL;
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnPal()
{
  COLORREF std = RGB( m_ColR.GetPos(), m_ColG.GetPos(), m_ColB.GetPos() );
  CColorDialog dialog( std, 0, this );
  if ( dialog.DoModal() == IDOK ) std = dialog.GetColor();
  m_ColR.SetPos( GetRValue( std ) );
  m_ColG.SetPos( GetGValue( std ) );
  m_ColB.SetPos( GetBValue( std ) );
  AddText();
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnShbut()
{
  Short->DoModal();
}

/////////////////////////////////////////////////////////////////////////////

void CSetupDlg::OnFont()
{
  CFontDialog cfd(&tFont);
  cfd.GetCurrentFont(&tFont);
  if (cfd.DoModal()==IDOK) if (Language==US) ::MessageBox(NULL,"You have to restart LANChat to activate font changes (if any).","LANChat 4.0",MB_OK|MB_ICONINFORMATION);
    else ::MessageBox(NULL,"Musisz ponownie uruchomi LANChata by ewentualna zmiana czcionki wesza w ycie.","LANChat 4.0",MB_OK|MB_ICONINFORMATION);
}
