/*
    LANChat 4.0 for Windows 95OSR2/98/NT4
   --------------------------------------------------------
    (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)
 
    LANChat and related utilities are free software; you can
    redistribute it and/or modify it under the terms of the GNU Library
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.
 
*/

#include "stdafx.h"
#include "LANChat.h"
#include "TopicDlg.h"

/////////////////////////////////////////////////////////////////////////////

CTopicDlg::CTopicDlg( CWnd* pParent )
    : CDialog( CTopicDlg::IDD, pParent )
{
  //{{AFX_DATA_INIT(CTopicDlg)
  m_CTopicDlg = _T( "" );
  m_S_Char = _T("");
  m_S_Chars = _T("");
  m_S_Words = _T("");
  //}}AFX_DATA_INIT
}

/////////////////////////////////////////////////////////////////////////////

void CTopicDlg::DoDataExchange( CDataExchange* pDX )
{
  CDialog::DoDataExchange( pDX );
  //{{AFX_DATA_MAP(CTopicDlg)
  DDX_Text( pDX, IDC_EDIT1, m_CTopicDlg );
  DDV_MaxChars( pDX, m_CTopicDlg, 75 );
  DDX_Text(pDX, IDC_S_CHAR, m_S_Char);
  DDX_Text(pDX, IDC_S_CHARS, m_S_Chars);
  DDX_Text(pDX, IDC_S_WORDS, m_S_Words);
  //}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP( CTopicDlg, CDialog )
//{{AFX_MSG_MAP(CTopicDlg)
ON_WM_SHOWWINDOW()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CTopicDlg::OnShowWindow( BOOL bShow, UINT nStatus )
{
  CDialog::OnShowWindow( bShow, nStatus );

  SetDlgItemInt( IDC_BYT, ( UINT ) Bytes, FALSE );
  SetDlgItemInt( IDC_CHAT, ( UINT ) ChatMessages, FALSE );
  SetDlgItemInt( IDC_TOT, ( UINT ) TotalMessages, FALSE );
  SetDlgItemText( IDC_START, Start );
  SetDlgItemText( IDC_TTIME, Time );

  int i;
  unsigned long mi=0,Mi;
  char test[5];

  for(i=0;i<255;i++) if (Owner->CHO[i]>=mi && i!=32 && i!=13 && i!=10)
    {
      mi=Owner->CHO[i];
	  Mi=i;
    }
  wsprintf(test,"%c",Mi);
  if (Mi>31 && Mi<129 && mi>0) m_S_Char=test; else m_S_Char="";

  mi=0;
  for(i=0;i<255;i++) if (Owner->Chars[i]>=mi)
    {
      mi=Owner->Chars[i];
	  Mi=i;
    }
  if (Mi!=255 && Mi!=0 && mi>0) m_S_Chars=Owner->Nick[Mi]; else m_S_Chars="";

  mi=0;
  for(i=0;i<255;i++) if (Owner->Words[i]>=mi)
    {
      mi=Owner->Words[i];
	  Mi=i;
    }
  if (Mi!=255 && Mi!=0 && mi>0) m_S_Words=Owner->Nick[Mi]; else m_S_Chars="";

  m_CTopicDlg = cTopic;
  if ( strcmp( cTopic, "<>" ) == 0 ) m_CTopicDlg.Empty();
  UpdateData( FALSE );
}

/////////////////////////////////////////////////////////////////////////////

void CTopicDlg::OnOK()
{
  UpdateData( TRUE );
  if ( ( m_CTopicDlg == "" ) && ( strcmp( cTopic, "<>" ) != 0 ) ) m_CTopicDlg = "I didn't like the topic ";
  if ( ( m_CTopicDlg == "" ) && ( strcmp( cTopic, "<>" ) == 0 ) ) m_CTopicDlg = "<>";
  if ( m_CTopicDlg.GetLength() > 75 ) {}
     else strcpy( cTopic, ( LPCTSTR ) m_CTopicDlg );
  m_CTopicDlg.Empty();
  ShowWindow( SW_HIDE );
  tCh = 1;
  Owner->SendMessage( WM_TIMER, 2, 2 );
  CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////

BOOL CTopicDlg::OnInitDialog()
{
  CDialog::OnInitDialog();
  if ( Language == PL )
  {
    SetDlgItemText( IDC_REC, "Bajtw:" );
    SetDlgItemText( IDC_CHATMSG, "Wiadomoci:" );
    SetDlgItemText( IDC_TOTALMSG, "Pakietw:" );
    SetDlgItemText( IDC_STOPIC, "Temat:" );
    SetDlgItemText( IDC_STARTED, "Rozpoczto:" );
    SetDlgItemText( IDCANCEL, "Anuluj" );
    SetDlgItemText( IDC_TSET, "Temat od:" );
    SetDlgItemText( IDC_COMMON, "Najczstszy znak:" );
    SetDlgItemText( IDC_MOST_CHARS, "Najwicej znakw napisa:" );
    SetDlgItemText( IDC_MOST_WORDS, "Najwicej sw napisa:" );
    SetWindowText( "Waciwoci sesji" );
  }
  return TRUE;
}
