/*
    LANChat 4.0 for Windows 95OSR2/98/NT4
   --------------------------------------------------------
    (C) 1998, 1999 Piotr Kowalski (goro@vc.pl)
 
    LANChat and related utilities are free software; you can
    redistribute it and/or modify it under the terms of the GNU Library
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.
 
*/

#include "stdafx.h"
#include "LANChat.h"
#include "UsersDlg.h"

/////////////////////////////////////////////////////////////////////////////

CUsersDlg::CUsersDlg( CWnd* pParent)
    : CDialog( CUsersDlg::IDD, pParent )
{
  //{{AFX_DATA_INIT(CUsersDlg)
  //}}AFX_DATA_INIT
}

/////////////////////////////////////////////////////////////////////////////

void CUsersDlg::DoDataExchange( CDataExchange* pDX )
{
  CDialog::DoDataExchange( pDX );
  //{{AFX_DATA_MAP(CUsersDlg)
  DDX_Control( pDX, IDC_LUSERS, m_LUsers );
  //}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP( CUsersDlg, CDialog )
//{{AFX_MSG_MAP(CUsersDlg)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CUsersDlg::Clear( void )
{
  m_LUsers.DeleteAllItems();
  users = 0;
}

/////////////////////////////////////////////////////////////////////////////

void CUsersDlg::AddUser( char *data )
{
  char _nick[ 25 ];
  char _userhost[ 70 ];
  char _IP[ 20 ];
  char _version[ 30 ];
  char _os[ 10 ];
  char _aw[ 5 ];
  char _since[ 15 ];
  char c[ 2 ];

  strcpy( _nick, "" );
  strcpy( _userhost, "" );
  strcpy( _IP, "" );
  strcpy( _version, "" );
  strcpy( _os, "" );
  strcpy( _aw, "" );
  strcpy( _since, "" );
  c[ 1 ] = '\0';
  unsigned int q;
  int f = 0;
  for ( q = 0; q < strlen( data ); q++ )
  {
    c[ 0 ] = data[ q ];
    if ( c[ 0 ] == '\x07' )
    {
      f++; continue;
    }
    if ( c[ 0 ] == 0x0d || c[ 0 ] == 0x0a ) continue;
    switch ( f )
    {
    case 0: strcat( _nick, c ); break;
    case 1: strcat( _userhost, c ); break;
    case 2: strcat( _IP, c ); break;
    case 3: strcat( _version, c ); break;
    case 4: strcat( _os, c ); break;
    case 5: strcat( _aw, c ); break;
    case 6: strcat( _since, c ); break;
    }
  }

  LV_ITEM lvi;

  lvi.iItem = users;
  lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
  lvi.iSubItem = 0;
  lvi.pszText = _nick;
  if ( _aw[ 0 ] == '0' ) lvi.iImage = 0; else lvi.iImage = 1;
  lvi.stateMask = LVIS_STATEIMAGEMASK;
  lvi.state = INDEXTOSTATEIMAGEMASK( 1 );

  LV_FINDINFO lvf;
  lvf.flags=LVFI_STRING|LVFI_WRAP;
  lvf.psz=_nick;

  if (m_LUsers.FindItem(&lvf,-1)==-1)
  {
    m_LUsers.InsertItem( &lvi );
    m_LUsers.SetItemText( users, 1, _userhost );
    m_LUsers.SetItemText( users, 2, _IP );
    m_LUsers.SetItemText( users, 3, _version );
    m_LUsers.SetItemText( users, 4, _os );
    m_LUsers.SetItemText( users, 5, _since );
    users++;
  }
}

/////////////////////////////////////////////////////////////////////////////

BOOL CUsersDlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  users = 0;

  Mordy.Create( IDB_USERLIST, 16, 1, RGB( 255, 255, 255 ) );
  m_LUsers.SetImageList( &Mordy, LVSIL_SMALL );

  char Kolumny[ 6 ][ 20 ] = {"Nick", "User", "IP", "Ver", "OS", "Since"};

  LV_COLUMN lvc;
  int i;

  lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
  for ( i = 0; i < 6; i++ )
  {
    lvc.iSubItem = i;
    lvc.pszText = Kolumny[ i ];
    switch ( i )
    {
    case 0: lvc.cx = 80; break;
    case 1: lvc.cx = 120; break;
    case 2: lvc.cx = 90; break;
    case 3: lvc.cx = 90; break;
    case 4: lvc.cx = 90; break;
    case 5: lvc.cx = 90; break;
    }
    lvc.fmt = LVCFMT_LEFT;
    m_LUsers.InsertColumn( i, &lvc );
  }

  return TRUE;
}
